LOCAL INCLUDE 'MK4IN.INC'
C                                       Local include MK4IN
C                                       AIPSish stuff here

C                                       AIPS I/O buffer etc
      INCLUDE 'INCS:ZPBUFSZ.INC'   
      INTEGER   JBUFSZ
      REAL  BUFFER(UVBFSL)      
      COMMON /BUFRS/ JBUFSZ, BUFFER
C                                       AIPS Parameter defs.      
      INCLUDE 'INCS:PUVD.INC'
C
C
C                                       AIPS adverbs passed
      HOLLERITH XINFIL(12), XNAMOU(3), XCLAOU(2), XPOLNS, XSRC(4,30)
      REAL      XTR(8), XDOUVC, XSOUT, XDISO, APARM(10), XLAGS, CLINT,
     *   WTHRES
      INTEGER  SEQOUT, DISKO, CNOOUT, NUMHIS
      LOGICAL   DOUVC, DOBS
C
      COMMON /INPARM/ XINFIL, XSRC, XTR, XDOUVC, XNAMOU, XCLAOU, XSOUT,
     $   XDISO, XPOLNS, XLAGS, CLINT, WTHRES, APARM, SEQOUT, DISKO,
     $   CNOOUT, NUMHIS, DOUVC, DOBS  
C
C                                       Maximum number of sources in exp
C                                        = maximum size of SU table
      INTEGER MAXSOU
      PARAMETER (MAXSOU=1000)
C
C                                       Various CHARACTER variables
      CHARACTER INFILE*48, NAMOUT*12, CLAOUT*6, HISCRD(10)*64,
     *   OFILE*48, SULIST(MAXSOU)*16, REFDAY*8
      COMMON /CHRCOM/ INFILE, NAMOUT, CLAOUT, HISCRD, OFILE, SULIST,
     *   REFDAY 
C
C
C                                       Output file info
      DOUBLE PRECISION REFREQ, REFJD, BADWT, GODWT
      REAL  EPOCH, IATOFF, UVROT(2), SCNGST, CURINT
      INTEGER FILSIZ, FSTVIS, LSTVIS, CNTVIS, KLOCWT, NCHAN, NPOLN, NIF,
     *  ISTOK, CURSOU, DAYOFF, TOTSOL, BADSOL, RDOY
C
      COMMON /INFCOM/ REFREQ, REFJD, BADWT, GODWT, EPOCH, IATOFF, UVROT,
     *   SCNGST, CURINT,
     *   FILSIZ, FSTVIS, LSTVIS, CNTVIS, KLOCWT, NCHAN, NPOLN, NIF,
     *   ISTOK, CURSOU, DAYOFF, TOTSOL, BADSOL, RDOY
C
C
C                                       Tables and source stuff
      INTEGER NSOUR, IDSOUR(MAXSOU), SUBUFF(1024), SUKOLS(MAXSUC),
     *   SUNUMV(MAXSUC), ISURNO, CLBUFF(1024), CLKOLS(MAXCLC),
     *   CLNUMV(MAXCLC), ICLRNO,  FQKOLS(MAXFQC), FQNUMV(MAXFQC),IFQRNO
      COMMON /TABCOM/ NSOUR, IDSOUR,
     *   SUBUFF, SUKOLS, SUNUMV, ISURNO,
     *   CLBUFF, CLKOLS, CLNUMV, ICLRNO,
     *   FQKOLS, FQNUMV, IFQRNO
C
LOCAL END
LOCAL INCLUDE 'PTABLE.INC'
C                                       Parameters for data.
      INTEGER   MXM4FQ, MXANT, MXFQID
C                                       MXANT = Max. no antennas. Don't
C                                       change!
      PARAMETER (MXANT=50)
C                                       MXMKFQ = Max. no. MK4 channels
      PARAMETER (MXM4FQ=16)
C                                       No of observing bands
      PARAMETER (MXFQID=50)
C
LOCAL END
LOCAL INCLUDE 'SRCSEL.INC'
C                                       Include for source selection
C                                       common.
C
C                                       SRCLST = source names from
C                                        SOURCES adverb
C                                       NUMSRC = number of names in
C                                        SRCLST
C                                       DESEL = 1 if sources in
C                                        SRCLST are to be excluded from
C                                        selection
      CHARACTER SRCLST(30)*16
      INTEGER   NUMSRC, DESEL
      COMMON /CSRCSL/ SRCLST
      COMMON /SRCSEL/ NUMSRC, DESEL
      SAVE /CSRCSL/, /SRCSEL/
C
LOCAL END
LOCAL INCLUDE 'MKINP.INC'
C                                       Some global parameters.
      INTEGER MKPRNT, MKPOL1, MKPOL2, MKNPOL, MKNLAG
C
      COMMON /MKAINP/ MKPRNT, MKPOL1, MKPOL2, MKNPOL, MKNLAG 
C
LOCAL END
LOCAL INCLUDE 'MKSTA.INC'
C                                       Antenna-based parameters.
      INTEGER NANT, MNTANT(MXANT)
      REAL ANTXOF(MXANT)
      DOUBLE PRECISION  DTALOC(3,MXANT), DTAEPO(MXANT), DTASYN(MXANT),
     *   DTAEP1(MXANT), DTACLK(MXANT)
      COMMON /ANTTB/ DTALOC, DTAEPO, DTASYN, DTAEP1, DTACLK,
     *   MNTANT, ANTXOF, NANT
C
C                                       Character variables
      CHARACTER  ANTNAM(MXANT)*8
      COMMON /MKACHR/ ANTNAM
C
LOCAL END
LOCAL INCLUDE 'MK4TAB.INC'
C                                       Parameter tables.
C                                       Source-based parameters.
      INTEGER ITNAFQ(MXFQID), NTAFQT, MKAFRQ(MXFQID),
     *   IFSIDE(MXFQID,MXM4FQ), MKAIF
      REAL BWIFS(MXFQID)
      DOUBLE PRECISION DRAEPO(MAXSOU), DECEPO(MAXSOU), DEPOCH(MAXSOU),
     *   DRAAPP(MAXSOU), DECAPP(MAXSOU), DTAFQT(MXFQID,MXM4FQ) 
      COMMON /SRCTB/ DRAEPO, DECEPO, DEPOCH, DRAAPP, DECAPP 
C                                       AIPS FQ table.
      COMMON /FRQATB/ DTAFQT, ITNAFQ, NTAFQT, BWIFS, MKAFRQ,
     *   IFSIDE, MKAIF
C                                       AN-Table parameters
      DOUBLE PRECISION DTWOB(2), DTUT1, DTGAST, DTSIDD
      COMMON /ANTPAR/  DTWOB, DTUT1, DTGAST, DTSIDD
C
LOCAL END
LOCAL INCLUDE 'MKSCN.INC'
C                                       Scans from OVEX and relates
C                                       stuff needed for CL times
C
C                                       Maximum number of scans
      INTEGER MAXSCN
      PARAMETER (MAXSCN=3000)
C                                       SCAN start and stop times
      DOUBLE PRECISION STRSCN(MAXSCN), STPSCN(MAXSCN)
C                                      Flags to indicate status for CL
      INTEGER NSCANS, SCNDON(MAXSCN)
C
      COMMON /SCNLIS/ STRSCN,  STPSCN,  NSCANS, SCNDON
LOCAL END     
LOCAL INCLUDE 'BSREC.INC'
C
C   BS table record buffer
C
      INCLUDE 'INCS:PUVD.INC'
C
      DOUBLE PRECISION TUTS
C                                       Centre time for the solution
C                                       interval in days from 0h on the
C                                       reference day.
C
      REAL      INTTS
C                                       Time interval covered by the
C                                       solution in days.
C
      INTEGER   BASELN(2)
C                                       The numbers of the antennae
C                                       defining the baseline.
C
      INTEGER   SUBARR
C                                       The subarray number
C
      INTEGER   STOKES
C                                       The stokes code
C
      INTEGER   SOURCB
C                                       The source ID number
C
      REAL      VAMP
C                                       The amplitude of the vector sum
C                                       of the post-fringe visibilities
C                                       for each IF in Jy.
C
      REAL      SAMP
C                                       The sum of the scalar visibility
C                                       amplitudes for each IF over the
C                                       solution interval.
C
      REAL      RMBD, MBDERR, MBDAMB
C                                       The residual multiband delay,
C                                       delay error and ambiguity (sec).
C
      REAL      RSBD, SBDERR, SBDAMB
C                                       The residual single-band delay
C                                       and error and the
C                                       single-band delay ambiguity
C                                       (sec).
C
      REAL      RRATE, RTERR, RTAMB
C                                       The residual rate and error 
C                                       and the rate ambiguity
C                                       in Hz.
C
      REAL      RACCEL, ACCERR
C                                       The residual acceleration and
C                                       error are not used
C
      REAL      RPHASE, PHSERR
C                                       The residual phase and phase
C                                       error in degrees.
C
      INTEGER   BSROW
C                                       The next BS table row to write.
C
      INTEGER   BSIF
C                                       The number of IF entries in the
C                                       BS table. Here = 1
      INTEGER BSCOLS(MAXBSC), BSNUMV(MAXBSC)
C                                       Need only 21 for MK3 mode
C
      INTEGER BSBUFF(512)
C
C
      COMMON /BSREC/ TUTS, INTTS, BASELN, SUBARR, STOKES, SOURCB,
     *   VAMP, SAMP, RMBD, MBDERR, MBDAMB, RSBD, SBDERR, SBDAMB, RRATE,
     *   RTERR, RTAMB, RACCEL, ACCERR, RPHASE, PHSERR, BSROW, BSIF,
     *   BSCOLS, BSNUMV, BSBUFF
      SAVE /BSREC/
C
LOCAL END
      PROGRAM MK4IN
C-----------------------------------------------------------------------
C! Reads UV data from MKIV CORRELATOR EXPT. DIRECTORY
C# UV-util VLB
C-----------------------------------------------------------------------
C;  Copyright (C) 1995-2001
C;  Associated Universities, Inc. Washington DC, USA.
C;  Max-Planck-Institut fr Radioastronomie, Bonn, Deutschland
C;
C;  This program is free software; you can redistribute it and/or
C;  modify it under the terms of the GNU General Public License as
C;  published by the Free Software Foundation; either version 2 of
C;  the License, or (at your option) any later version.
C;
C;  This program is distributed in the hope that it will be useful,
C;  but WITHOUT ANY WARRANTY; without even the implied warranty of
C;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C;  GNU General Public License for more details.
C;
C;  You should have received a copy of the GNU General Public
C;  License along with this program; if not, write to the Free
C;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,
C;  MA 02139, USA.
C;
C;  Correspondence concerning AIPS should be addressed as follows:
C;         Internet email: aipsmail@nrao.edu.
C;         Postal address: AIPS Project Office
C;                         National Radio Astronomy Observatory
C;                         520 Edgemont Road
C;                         Charlottesville, VA 22903-2475 USA
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C   MK4IN Reads uv data from a Haystack MKIV Correlator Expt. directory
C   Assumes that Ovex and Lvex files are present
C   Inputs:
C      AIPS adverb  Prg. name.          Description.
C      INFILE         INFILE        Input file name. (Data directory)
C      SOURCES        XSRC          Source selection list.
C      TIMERANG       XTR           Desired timerange.
C      DOUVCOMP       DOUVC         If true compress data.
C      OUTNAME        NAMOUT        Name of the output uv file.
C      OUTCLASS       CLAOUT        Class of the output uv file.
C      OUTSEQ         SEQOUT        Seq. number of output uv data.
C      OUTDISK        DISKO         Disk number of the output file.
C      STOKES         XPOLNS        Polarizations used in correlation
C      NPOINTS        XLAGS         Number of lags used for correlation
C      CLINT          CLINT         CL table increment
C      WTTHRES        WTHRES        Threshold for weight flagging
C      APARM          APARM         Control information.
C-----------------------------------------------------------------------
      INTEGER  IRET
      CHARACTER PRGM*6
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'SRCSEL.INC'
      INCLUDE 'MKINP.INC'
      INCLUDE 'MKSTA.INC'
      INCLUDE 'MK4TAB.INC'
      INCLUDE 'MKSCN.INC'
C
      DATA PRGM /'MK4IN '/
C-----------------------------------------------------------------------
C                                       Get input parameters and read
C                                       VEX-file  and
      CALL MK4INN (PRGM, IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Read data
      CALL MK4UV (IRET)
      IF (IRET.NE.0) GO TO 990
C                                       Write AN, FQ, HI tables.
      CALL MK4TB
C                                       Close down files, etc.
 990  CALL DIE (IRET, BUFFER)
C
 999  STOP
      END
      SUBROUTINE MK4INN (PRGN, IRET)
C-----------------------------------------------------------------------
C   MK4INN gets input parameters for MK4IN and reads VEX file(s). Stores
C   all necessary stuff for tables, file header and consistency checks
C   Inputs:
C      PRGN    C*6  Program name
C   Output:
C      IRET    I    Error code: 0 => ok
C                               1 => INFILE name wrong: no exp No.
C                               2 => error reading ovex file.
C                               3 => error getting value from vex file
C                               4 => error creating output file.
C                               5 => Temporary: more than 1 freq setup
C                               8 => can't start
C   Input/output via common
C      ANTNAM   C*8(ant#)  Antenna name.
C      APARM    R(10)      AIPS input parameter values.
C      BWIFS    R(#fid)    Bandwidth of IFs in each FQ id
C      BUFFER   R(UVBFSS)  Work buffer.
C      CLAOUT   C*6        Output file type.
C      DECAPP   D(MAXSOU)  apparent DEC
C      DECEPO   D(MAXSOU)  DEC at  DEPOCH (deg)
C      DEPOCH   D(MAXSOU)  Epoch for RA and DEC (e.g. 1590 or 2000)      
C      DESEL    I          Source selection sense flag
C      DISKO    I          Output disk number.
C      DOUVC    L          Compress output file ?
C      DRAAPP   D(MAXSOU)  apparent RA (deg)
C      DRAEPO   D(MAXSOU)  RA at  DEPOCH (deg)
C      DTACLK   D(ant#)    Station clock rate (us/s)
C      DTAEPO   D(ant#)    Station clock epoch
C      DTAEP1   D(ant#)    Station clock-rate epoch
C      DTGAST   D          GAST at 0 UT on refday (rad).
C      DTSIDD   D          d(GAST)/d(UT) on refday (rad/s).
C      DTAFQT   D(fid#,if#) Set of AIPS IF frequencies for each
C                           IF if#. Each set of frequencies is
C                           identified by the FQ id fid# (Hz)
C      DTALOC   D(3,ant#)  X,Y,Z coordinates for antenna ant# using
C                          right-handed axes.
C      DTASYN   D(ant#)    Station clock offset (us) 
C      IATOFF   R          IAT-UTC (seconds).
C      IFSIDE   I(fid#,if#) Sideband of each IF in each FQ set
C      INFILE   C*48       Input file name.
C      ISURNO   I          Next scan number in SU table.
C      ITNAFQ   I(fid#)    No of IFs in each frequency set.
C      JBUFSZ   I          Buffer size in AIPS bytes.
C      MKAFRQ   I(fid#)    No of frequency channels per spectrum per FQ
C                          id. (Should all be the same in this vers)
C      MKNLAG   I          No of lags in each correlation function
C                          in output file.
C      MKNPOL   I          No of polarizations in output file.
C      MKPOL1   I          Min polzn code for output file
C                          (1=RR,2=LL,3=RL,4=LR).
C      MKPOL2   I          Max polzn code for output file.
C      MKVPOL   I(fid#,if#) Pol from vex (1=RR,2=LL) (not yet used)
C      MKPRNT   I          Print level (0..4).
C      MSGTXT   C*80       AIPS message string.
C      NAMOUT   C*12       Output file name.
C      NTAFQT   I          No of entries in ITNAFQ.(fid#)
C      NANT     I          No of antennas in antenna list.
C      NCFILE   I          No of catalog files marked.
C      NSCR     I          No of scratch files created.
C      NSOUR    I          No of sources that will be used
C      NUMHIS   I          Number of history records.
C      NUMSRC   I          Number of entries in SRCLST
C      REFDAY   C*8        Reference day ('yyyymmdd').
C      REFJD    D          Reference Julian day no for output file.
C      RQUICK   L          Restart AIPS ?
C      SEQOUT   I          Output file sewquence number.
C      SRCLST   C(30)*16   Source selection list
C      SULIST   C(100)*16  Source list; NSOUR will be used
C      XCLAOU   H(2)       Output file type.
C      XDISO    R          Output disk number.
C      XDOUVC   R          >0 Compress output file.
C      XINFIL   H(12)      Experiment file name.
C      XNAMOU   H(3)       Output file name.
C      XSOUT    R          Output file sequence number.
C      XSRC     H(4, 30)   Source selection list.
C      XTR      R(8)       Time range (start: day, hh, mm, ss,
C                          stop: day, hh, mm, ss).
C      WTHRES   R          Weight threshold
C      STRSCN   D(#scans)  Start time of scans
C      STPSCN   D(#scans)  Stop time of scans
C      SCNDON   I(#scans)  Status of scans for CL table
C-----------------------------------------------------------------------
      INTEGER   IRET, EXPNO, I, J
      CHARACTER PRGN*6, CPOLNS*4
C
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'MK4TAB.INC'
      INCLUDE 'MKINP.INC'
      INCLUDE 'MKSTA.INC'
      INCLUDE 'SRCSEL.INC'
      INCLUDE 'MKSCN.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DANT.INC'
C
      INTEGER   IERR, NPARM, IROUND, ITRIM, JSIDE(MXFQID), KSIDE, CORAMP
      CHARACTER*48 FNAME
C
C      CHARACTER DMS*15, HMS*15
C-----------------------------------------------------------------------
C                                       Init for AIPS, disks, ...
      CALL ZDCHIN (.TRUE.)
      CALL VHDRIN
      JBUFSZ = UVBFSL * 2
      NUMHIS = 0
C                                       Initialize /CFILES/
      NSCR = 0
      NCFILE = 0
      IRET = 0
C                                       Get input parameters.
      NPARM = 163
      CALL GTPARM (PRGN, NPARM, RQUICK, XINFIL, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         RQUICK = .TRUE.
         IRET = 8
         IF (IERR.EQ.1) GO TO 999
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (8)
         END IF
C                                       Restart AIPS
      IF (RQUICK) CALL RELPOP (IRET, BUFFER, IERR)
      IF (IRET.NE.0) GO TO 999
C                                       Crunch input parameters.
      SEQOUT = IROUND (XSOUT)
      DISKO = IROUND (XDISO)
      DOUVC = XDOUVC.GT.0.0

C                                       Convert AIPS character adverbs
C                                       from HOLLERITH to CHARACTER.
      CALL H2CHR (48, 1, XINFIL, INFILE)
      CALL H2CHR (12, 1, XNAMOU, NAMOUT)
      CALL H2CHR (6, 1, XCLAOU, CLAOUT)
C
C                                       Which polarizatins were
C                                       correlated
      CALL H2CHR (4, 1, XPOLNS, CPOLNS)      
      MKPOL1 = 999
      MKPOL2 = -999
      IF( CPOLNS .EQ. 'ALL ' .OR. CPOLNS .EQ. '    ' ) THEN
         MKPOL1 = 1
         MKPOL2 = 4
      ELSE IF( CPOLNS .EQ. 'LLRR' .OR. CPOLNS .EQ. 'RRLL' ) THEN
         MKPOL1 = 1
         MKPOL2 = 2
      ELSE IF( CPOLNS .EQ. 'LL  ' ) THEN
         MKPOL1 = 2
         MKPOL2 = 2
      ELSE IF( CPOLNS .EQ. 'RR  ' ) THEN
         MKPOL1 = 1
         MKPOL2 = 1
      ELSE
C                                       Unidentified Stokes parameter.
         WRITE (MSGTXT,1400) CPOLNS
         CALL MSGWRT (8)
         IRET = 2
         GO TO 990
         END IF
C
      MKNPOL = MKPOL2 - MKPOL1 + 1
C
C                                       Get number of correlation lags
      IF( XLAGS .EQ. 0. ) XLAGS = 32.
      MKNLAG = XLAGS + 0.1
C                                
C                                       Set source selection criteria
      CALL SETSRC (XSRC)
C                                       CL increment in days
      CLINT = CLINT/60./24.
C                                       Create BS table ?
      IF (APARM(1).EQ.0) THEN
         DOBS = .TRUE.
      ELSE
         DOBS = .FALSE.
         ENDIF
C                                       Print level
      MKPRNT = APARM(2) + 0.5
      IF (MKPRNT .LT. 0) MKPRNT = 0
C                                       Do we need AMP correction
      CORAMP = APARM(4)
C                                       Timesystem. Default UTC
      TIMSYS = 'UTC'
C
C                                       Check if name with logical
      IF (INDEX(INFILE,':') .GT. 0) THEN
C                                       Crack name
         CALL ZFULLN(INFILE, ' ', '     ', FNAME, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1008) IERR
            CALL MSGWRT (8)
            IRET = 1
            GO TO 999
            ENDIF
            INFILE = FNAME
         ENDIF
C
C                                       Check Infile (DIR) format 
      CALL CH2NUM(ITRIM(INFILE)-3, ITRIM(INFILE), INFILE, EXPNO, IERR)
      IF (IERR.NE.0) THEN
         IRET = 1
         WRITE (MSGTXT,1001) EXPNO
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
C                                       Set TIMERANG 
      IF ((XTR(5)+XTR(6)+XTR(7)+XTR(8)) .LE. 1.0E-10) XTR(5) = 999.0
      CALL VXTIMERANG(INT(XTR(1)),INT(XTR(2)),INT(XTR(3)),INT(XTR(4)),
     *   INT(XTR(5)),INT(XTR(6)),INT(XTR(7)),INT(XTR(8)) )
C
C                                       Read, parse and store Ovex-file
      CALL INIVEX( INFILE, EXPNO, MKPRNT, CORAMP, IERR )
      IF (IERR.NE.0) THEN
         IRET = 2
         WRITE (MSGTXT,1002) IERR, EXPNO
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
C                                       Get reference JD and EOP from
C                                       ovex. DTGAST, DTSIDD will be
C                                       taken from MK4UVW instead
      CALL VXREFD( REFDAY, DTWOB, DTUT1, IATOFF, DTGAST, DTSIDD, RDOY,
     *   IERR ) 
      IF (IERR.NE.0) THEN
         IRET = 3
         WRITE (MSGTXT,1003) REFDAY
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       We are not safe without this!
      IF (TIMSYS .EQ. 'UTC') IATOFF = 0
C
      CALL JULDAY (REFDAY, REFJD)
C                                       JULDAY sets its second argument
C                                       to 0.0 if the first argument
C                                       is not in the correct format.
      IF (REFJD.EQ.0.0D0) THEN
         WRITE (MSGTXT, 1004)
         IRET = 1
         GO TO 990
         END IF
C                                       reformat if needed
      CALL GREG (REFJD, REFDAY)
C                                       Get Antenna info plus
C                                       clocken...
      CALL VXANT( NANT, ANTNAM, DTALOC, ANTXOF, MNTANT, DTASYN, DTAEPO,
     *   DTACLK, DTAEP1, IERR )
      IF (IERR.NE.0) THEN
         IRET = 3
         WRITE (MSGTXT,1005) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
C                                       Get sources from VEX file
      CALL VXSOU( NUMSRC, DESEL, SRCLST, NSOUR, SULIST, DRAEPO, DECEPO,
     *   DEPOCH, DRAAPP, DECAPP, IERR ) 
      IF (IERR.NE.0) THEN
         IRET = 3
         WRITE (MSGTXT,1006) IERR 
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
C      DO 60 I = 1,NSOUR
C         WRITE (MSGTXT,1080) SULIST(I), HMS(DRAEPO(I),3),
C     *      DMS(DECEPO(I),4), HMS(DRAAPP(I),3), DMS(DECAPP(I),4) 
C 1080    FORMAT (A8,2X,2(A12,1X,A13,1X))
C         CALL MSGWRT (6)
C 60      CONTINUE
C                                       Get # of IFs and channels 
      MKAFRQ(1) = MKNLAG
      CALL VXFREQ( NTAFQT, ITNAFQ, DTAFQT, BWIFS, MKAFRQ, IFSIDE,
     *   IERR ) 
      IF (IERR.NE.0) THEN
         IRET = 3
         WRITE (MSGTXT,1007) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C         write(*,*)ntafqt,ITNAFQ, DTAFQT, BWIFS, MKAFRQ, IFSIDE
C                                       If more than 1 FQID may be
C                                       problem conject BS table
      IF (NTAFQT.GT.1 .AND. DOBS) THEN
C         DOBS = .FALSE.
         WRITE (MSGTXT,1010) NTAFQT
         CALL MSGWRT (5)
         WRITE (MSGTXT,1011)
         CALL MSGWRT (5)
         ENDIF
C                                       Initialize solution count
      TOTSOL = 0
      BADSOL = 0
C                                       Deterimine max # of IFs per FQID
C                                       and if double sideband. Should
C                                       be changed!
      MKAIF = 0
      KSIDE = 0
      DO 700 I = 1, NTAFQT
         JSIDE(I) = 0
         DO 690 J = 1, ITNAFQ(I)
            JSIDE(I) = JSIDE(I) + IFSIDE(I,J)
 690        CONTINUE
C                                       Check for mixed setups
         IF (JSIDE(I).NE.0 .AND. ABS(JSIDE(I)).NE.ITNAFQ(I)) THEN
            IRET = 5
            WRITE (MSGTXT,1009) 
            CALL MSGWRT (8)
            GO TO 999
            END IF
C                                       Set Number of reqeuncy channels
C                                       has to 2* for DSB
         IF (JSIDE(I) .EQ. 0) THEN
            MKAFRQ(I) = 2 * MKNLAG
         ELSE
            MKAFRQ(I) = MKNLAG
            END IF
         KSIDE = KSIDE + JSIDE(I)/ITNAFQ(I)
 700     MKAIF = MAX( MKAIF, ITNAFQ(I) )
C                                       Check again if only 1 kind
C                                       Changed this for LSB-only caes!?
      IF (KSIDE .NE. 0 .AND. ABS(KSIDE) .NE. NTAFQT) THEN
         IRET = 5
C         write(*,*)"KSIDE,NTAFQT", KSIDE,NTAFQT
         WRITE (MSGTXT,1009) 
         CALL MSGWRT (8)
         GO TO 999
         END IF
C 
C                                       Read Scan list
      CALL SCNLST (MAXSCN, NSCANS, STRSCN, STPSCN, IERR) 
      IF (IERR.NE.0) THEN
         IRET = 3
         WRITE (MSGTXT,1012) IERR 
         CALL MSGWRT (8)
         GO TO 999
         END IF
C
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MK4INN: ERROR',I3,' OBTAINING INPUT PARAMETERS')
 1008 FORMAT ('MK4INN: ERROR',I3,' cracking dirname ')
 1001 FORMAT ('MK4INN: ERROR IN INFILE NAME. EXPNO WRONG',I5)
 1002 FORMAT ('MK4INN: ERROR',I3,' IN READING OVEX FILE.',I5,'.ovex')
 1003 FORMAT ('MK4INN: ERROR GETTING REFDAY FROM OVEX FILE:',A8)
 1004 FORMAT ('MK4INN: ERROR: BAD REFDATE FORMAT')
 1005 FORMAT ('MK4INN: ERROR',I3,' GETTING STATION PARAMS FROM OVEX FILE 
     *    ' ) 
 1006 FORMAT ('MK4INN: ERROR',I3,' GETTING SOURCE PARAMS FROM OVEX FILE'
     *     ) 
 1007 FORMAT ('MK4INN: ERROR',I3,' GETTING FREQUENCY PARAMS FROM OVEX FI
     *ILE') 
 1009 FORMAT ('MK4INN: ERROR - Illegal sideband combinations')
 1010 FORMAT ('WARNING! Found',I3,' FQIDs and BS table wanted')
 1011 FORMAT ('WARNING! BS-Table may not be usable (e.g. for S/X)')
 1012 FORMAT ('MK4INN: ERROR',I3,' reading scan list')
 1400 FORMAT ('MK4INN: ERROR: Unidentified Stokes parameter: ',A4)
      END
      SUBROUTINE SETSRC (XSRC)
C-----------------------------------------------------------------------
C   Set source selection criteria from the SOURCES adverb.
C
C   Inputs:
C      XSRC    H(4, 30)    SOURCES adverb
C
C   Outputs (in common):
C      SRCLST  C(30)*16    Source names from SOURCES adverb with any
C                           leading '-'s removed.
C      NUMSRC  I           Number of entries in SRCLST
C      DESEL   I           Deselection flag.  If 1 sources in
C                           SRCLST will not be selected
C-----------------------------------------------------------------------
      HOLLERITH XSRC(4, 30)
C
      CHARACTER SRCNAM*16
      INTEGER   I
C
      INCLUDE 'SRCSEL.INC'
C-----------------------------------------------------------------------
      NUMSRC = 0
      DESEL = 0
      DO 10 I = 1, 30
C                                       Decode source name
         CALL H2CHR (16, 1, XSRC(1, I), SRCNAM)
         IF (SRCNAM.NE.' ') THEN
C                                       Add source to source list and
C                                       update deselection flag.
            NUMSRC = NUMSRC + 1
            IF (SRCNAM(1:1).EQ.'-') THEN
               DESEL = 1
               SRCLST(NUMSRC) = SRCNAM(2:16)
            ELSE
               SRCLST(NUMSRC) = SRCNAM
               END IF
            END IF
   10    CONTINUE
C
      END
      SUBROUTINE MK4UV (IRET)
C-----------------------------------------------------------------------
C   MK4UV reads uv data one point at a time from MK4DAT and then writes
C   the data.
C   Output:
C      IRET   I  Return code, 0 => OK, otherwise abort.
C   Input from common
C      CURSOU   I          Current source number in SU table.
C      CURINT   R          Data integration time (seconds)
C      FILSIZ   I          Output file size.
C      FSTVIS   I          First visibility no in output file.
C      ILOCB    I          Offset from start of vis rec for baseline.
C      ILOCFQ   I          Offset from start of vis rec for freq id.
C      ILOCSU   I          Offset from start of vis rec for source id
C      LREC     I          Length in values of a visibility record.
C   Input/output via common
C      BUFFER   R(UVBFSS)  Work buffer.
C      MSGTXT   C*80       AIPS message string.
C      CNTVIS   I          Number of visibilities in output file
C      ILOCT    I          Offset from start of vis record for Time.
C      ILOCU    I          Offset from start of vis record for U.
C      ILOCV    I          Offset from start of vis record for V.
C      ILOCW    I          Offset from start of vis record for W.
C      NRPARM   I          Number of random parameters.
C-----------------------------------------------------------------------
      INTEGER   IRET, IERR
C
      INTEGER   IPTRO, LUNO, IA1, IA2, NIOUT, INDO, KBIND, NUMVIS,
     *   NVS, VISBUF, IFQAID, IAREF, LUNB, VER, NUMPOL, NUMANT, NTERM
      REAL      IBUFF(256), GMMOD
      CHARACTER MODE*4
      LOGICAL   LAST
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'MKSTA.INC'
      INCLUDE 'BSREC.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
      DATA LUNO /16/
      DATA GMMOD /1.0/
      DATA MODE /'MK3 '/
C-----------------------------------------------------------------------
      NIOUT = 0
      NUMVIS = 0
      CNTVIS = 0
      IPTRO = 1
      ILOCV = 0
      ILOCU = 0
      ILOCW = 0
      ILOCT = 0
      NRPARM = 0
      IA1 = 0
      IA2 = 0
      LAST = .FALSE.
C                                       Create/init output file
      CALL MK4OPN (LUNO, INDO, VISBUF, IPTRO, IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Create BS table
      VER = 1
C
      IF (DOBS) THEN
         LUNB = 29
*         write(*,*) BSBUFF, DISKO, CNOOUT, VER, CATBLK, LUNB,
*     *      BSROW, BSCOLS, BSNUMV, 'MK3 ', BSIF, IRET
         CALL BSINI ('WRIT', BSBUFF, DISKO, CNOOUT, VER, CATBLK, LUNB,
     *      BSROW, BSCOLS, BSNUMV, MODE, BSIF, IRET)  
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET
            GO TO 990
            END IF
         ENDIF
C                                       Create CL table
      LUNB = 30
      NUMPOL = MIN (NPOLN, 2)
      NUMANT = NANT
C                                       3 terms for the model
      NTERM = 3
      CALL CALINI ('WRIT', CLBUFF, DISKO, CNOOUT, VER, CATBLK, LUNB,
     *   ICLRNO, CLKOLS, CLNUMV, NUMANT, NUMPOL, NIF, NTERM, GMMOD,
     *   IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C
C                                       Loop
 100  CONTINUE
         NUMVIS = NUMVIS + 1
C                                      Next vis
         CALL MK4DAT (BUFFER(IPTRO+ILOCU),
     *      BUFFER(IPTRO+ILOCV), BUFFER(IPTRO+ILOCW),
     *      BUFFER(IPTRO+ILOCT), IA1, IA2, IAREF, IFQAID,
     *      BUFFER(IPTRO+NRPARM), BUFFER(IPTRO), IRET)
C                                       Error (fatal)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1120) IRET
            CALL MSGWRT (8)
            GO TO 990
            END IF
C                                       Detected end of all data
         IF (IRET.EQ.-1) LAST = .TRUE.
C                                       Got datum
         CNTVIS = CNTVIS + 1
C                                       Update CATBLK on disk
C                                       Put vis. count in CATBLK
         CATBLK(KIGCN) = CNTVIS
         CALL CATIO ('UPDT', DISKO, CNOOUT, CATBLK, 'REST', IBUFF, IERR)
         IF (IERR.NE.0) THEN
            WRITE (MSGTXT,1050) IERR
            CALL MSGWRT (6)
            END IF
C                                       Fill in baseline, source, FQ id
         BUFFER(IPTRO+ILOCB) = IA1 * 256 + IA2 + 0.001 * (IAREF - 1)
         BUFFER(IPTRO+ILOCSU) = CURSOU
         BUFFER(IPTRO+ILOCFQ) = IFQAID
         BUFFER(IPTRO+ILOCIT) = CURINT
C                                       Update pointer, counter
         IPTRO = IPTRO + LREC
         NIOUT = NIOUT + 1
C                                       Time to write
         IF (NIOUT.GE.VISBUF .OR. LAST) THEN
C                                       Check for user signal
            CALL MK4TEL (IRET)
            IF (IRET.NE.0) GO TO 999
C                                       Expand file?
            IF (CNTVIS.GT.FILSIZ) THEN
C                                       Add 10000 vis.
               NVS = CNTVIS + 10000
               CALL MK4XPN (LUNO, NVS, IRET)
C                                        Say how much data
               WRITE (MSGTXT,1200) NUMVIS
               CALL MSGWRT (6)
               IF (IRET.NE.0) THEN
C                                       Expansion failed - save what
C                                       you've got.
                  MSGTXT = 'FILE EXPANSION FAILED - DISK FULL'
                  CALL MSGWRT (8)
                  CNTVIS = CNTVIS - NIOUT
                  NIOUT = 0
                  IRET = 0
                  GO TO 990
                  END IF
               END IF
C                                       Write vis record.
            CALL UVDISK ('WRIT', LUNO, INDO, BUFFER, NIOUT, KBIND, IRET)
C                                       Check for end.
            IF (IRET.GT.0) THEN
               WRITE (MSGTXT,1150) IRET
               GO TO 990
               END IF
            IPTRO = KBIND
            VISBUF = NIOUT
            NIOUT = 0
            END IF
C                                       Next vis.
         IF (.NOT.LAST) GO TO 100
C                                       Last orders please!
      IRET = 0
C                                       Have to write the tables
      CALL MK4SOU(IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1160) IRET
         GO TO 990
         END IF
C                                       Close BS table
      IF (DOBS) THEN
         SUBARR = 1
         CALL TABBS ('CLOS', BSBUFF, BSROW, BSCOLS, BSNUMV, BSIF,
     *      TUTS, INTTS, BASELN, SUBARR, STOKES, SOURCB, VAMP, SAMP,
     $      RMBD, MBDERR, MBDAMB, RSBD, SBDERR, SBDAMB, RRATE, RTERR,
     $      RTAMB,RACCEL, ACCERR, RPHASE, PHSERR, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1170) IRET
            GO TO 990
            END IF
         ENDIF
C
C                                       Close CL table
      CALL TABIO ('CLOS', 0, ICLRNO, CLBUFF, CLBUFF, IRET)
C                                       Say how much data
      WRITE (MSGTXT,1200) NUMVIS
      CALL MSGWRT (6)
C                                       Close down
      CALL MK4CLS (LUNO, INDO, KBIND, NIOUT, IRET)
      IF (IRET.NE.0) GO TO 990
      GO TO 999
C                                       Error
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR ',I3,' CREATING BS-TABLE')
 1010 FORMAT ('ERROR ',I3,' CREATING CL-TABLE')
 1050 FORMAT ('ERROR ',I3,' UPDATING OUTPUT CATALOG HEADER')
 1120 FORMAT ('MK4UV: MK4DAT ERROR',I3)
 1150 FORMAT ('MK4UV: ERROR',I3,' WRITING VIS FILE')
 1160 FORMAT ('MK4UV: ERROR',I3,' WRITING SU TABLE')
 1170 FORMAT ('MK4UV: ERROR',I3,' CLOSING BS TABLE')
 1200 FORMAT ('Read ', I7, ' visibilities')
      END
      SUBROUTINE MK4OPN (LUNO, INDO, VISBUF, IPTRO, IRET)
C-----------------------------------------------------------------------
C   Creates/ opens/ initializes the output file and writes FQ table
C   Input:
C      LUNO     I    Logical unit number to use for I/O
C   Output:
C      INDO     I    FTAB pointer for I/O
C      IRET     I    Return error code, 0=>OK, else failed.
C      VISBUF   I    The number of visibilities that fit in a buffer.
C      IPTRO    I    Pointer in buffer for next record.
C   Input from common
C      CATBLK   I(256)     Catalog header.
C      KDCRV    D(7)       Coordinate value at ref pixel.
C      KIIMS    I          Image sequence number.
C      KINAX    I(7)       Number of pixels on each axis.
C      CATD     D(128)     Catalog header.
C      JLOCF    I          Order in data of frequency.
C      JLOCIF   I          Order in data of IF.
C      JLOCS    I          Order in data of Stokes parameters.
C   Input/output via common
C      BUFFER   R(UVBFSS)  Work buffer.
C      JBUFSZ   I          Buffer size in words.
C      NCHAN    I          Number of frequency channels.
C      NIF      I          Number of IF's in output file.
C      NPOLN    I          Number of polarizations in output file.
C      REFREQ   D          Reference frequency (Hz) in catalog hdr.
C      SEQOUT   I          Output file sewquence number.
C      CNOOUT   I          Output file sequence number.
C      DISKO    I          Output disk number.
C      OFILE    C*48       Physical file name for output file.
C      LREC     I          Length in values of a visibility record.
C      FSTVIS   I          First visibility no in output file.
C      MSGTXT   C*80       AIPS message string.
C-----------------------------------------------------------------------
      INTEGER   LUNO, INDO, VISBUF, IPTRO, IRET
C
      INTEGER   LENBU, NVS, BO
      LOGICAL   T, F
      INCLUDE 'MK4IN.INC'

      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      DATA T, F /.TRUE.,.FALSE./
      DATA BO /1/
C-----------------------------------------------------------------------
C                                       Create new header.
      CALL MK4HED (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Get uv header info and
C                                       verify header structure.
      CALL UVPGET (IRET)
      IF (IRET.NE.0) GO TO 999
C                                       Put new values in CATBLK.
C                                       Create output file.
      CALL MK4CRE (IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET
         GO TO 990
         END IF
C                                       Reference Frequency
      REFREQ = CATD(KDCRV+JLOCF)
C                                       Number  of frequency channels
      NCHAN = CATBLK(KINAX+JLOCF)
C                                       Number of IFs.
      NIF = CATBLK(KINAX+JLOCIF)
C                                       Number of polarizations
      NPOLN = CATBLK(KINAX+JLOCS)
C                                       Get SEQ. no. used.
      SEQOUT = CATBLK(KIIMS)
C                                       Open vis file for write
      CALL ZPHFIL ('UV', DISKO, CNOOUT, 1, OFILE, IRET)
      CALL ZOPEN (LUNO, INDO, DISKO, OFILE, T, F, F, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1002) IRET
         GO TO 990
         END IF
C                                       Init vis file for write
      LENBU = 0
      NVS = 10000000
      CALL UVINIT ('WRIT', LUNO, INDO, NVS, FSTVIS, LREC, LENBU,
     *   JBUFSZ, BUFFER, BO, IPTRO, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1003) IRET
         GO TO 990
         END IF
      VISBUF = LENBU
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MK4OPN: ERROR',I3,' CREATING OUTPUT FILE')
 1002 FORMAT ('MK4OPN: ERROR',I3,' OPENING OUTPUT FILE')
 1003 FORMAT ('MK4OPN: ERROR',I3,' INITIALIZING I/O TO OUTPUT FILE')
      END
      SUBROUTINE MK4HED (IRET)
C-----------------------------------------------------------------------
C   MK4HED is a routine in which the catalog header is constructed.
C   Output:
C      IRET           I   Return error code, 0=>OK, otherwise abort.
C   Input from common
C      REFDAY   C*8        Reference day ('dd/mm/yy').
C      KDARV    D          Alt ref pixel value (freq or vel).
C      KDCRV    D(7)       Coordinate value at ref pixel.
C      KDODE    D          Antenna pointing (DEC).
C      KDORA    D          Antenna pointing (RA).
C      KDRST    D          Rest frequency of line (Hz).
C      KHBUN    H(2)       Map units (i.e Jy/beam).
C      KHCTP    H(2)(7)    Coordinate type (ie 'RA--SIN').
C      KHDOB    H(2)       Observation date in format ('DD/MM/YY').
C      KHINS    H(2)       Receiver or correlator.
C      KHOBJ    H(2)       Source name.
C      KHOBS    H(2)       Observer name.
C      KHPTP    H(2)(14)   Random parameter types.
C      KHTEL    H(2)       Telescope name (eg 'VLA').
C      KIALT    I          Velocity ref frame (1=LSR,2=Helio,
C                          3=Observer+256 if radio definition.
C      KICTPN   =7         Max number of axes.
C      KIDIM    I          Number of coordinate axes.
C      KIGCN    I          No of random parm groups (uv vis records)
C      KIIMU    I          Image user ID number.
C      KINAX    I(7)       Number of pixels on each axis.
C      KINIT    I          Number of CLEAN iterations.
C      KIPCN    I          Number of random parameters.
C      KIPTPN   =14        Max number of labelled random parameters.
C      KITYP    I          Clean map type (1-4:normal, components,
C                          residual, points; UV = sort order).
C      KRARP    R          Alt ref pixel location (freq or vel).
C      KRBLK    R          Value of indeterminate pixel (real maps).
C      KRBMJ    R          Beam major axis in degrees.
C      KRBMN    R          Beam minor axis in degrees.
C      KRBPA    R          Beam position angle in degrees.
C      KRCIC    R(7)       Coordinate value increment along axis.
C      KRCRP    R(7)       Coordinate reference pixel.
C      KRCRT    R(7)       Coordinate rotation angles.
C      KRDMN    R          Real value of data minimum.
C      KRDMX    R          Real value of data maximum.
C      KREPO    R          Epoch of coordinates (years).
C      KRXSH    R          Offset in X(rot RA) of phase centre.
C      KRYSH    R          Offset in Y(rot DEC) of tangent point.
C      DOUVC    L          Compress output file ?
C      MKAFRQ   I          No of freq channels per spectrum in
C                          output file.
C      MKAIF    I          Number of IF's in output file.
C      MKNPOL   I          No of polarizations in output file.
C      MKPOL1   I          Min polzn code for output file
C                          (1=RR,2=LL,3=RL,4=LR).
C      MKSIDB   I          0= Double sideband concatenation in
C                          output file.
C      MKAFQT   D(if#)     AIPS IF frequencies for the current
C                          scan baseline (Hz).
C      MKBASE   I          Baseline # of current scan-baseline data.
C      DEPOCH   D(100)     Epoch for RA and DEC (e.g. 1590 or 2000)     
C      MKSMRT   D(base#)   Formatter sample rate (bits/s).
C      NLUSER   I          User number.
C      DOSIDB   L          If true separate sidebands by IF
C   Input/output via common
C      REFDAY   C*8        Reference day ('dd/mm/yy').
C      KLOCWT   I          Offset of compress weight factor in
C                          random parameter array.
C      CATBLK   I(256)     Catalog header.
C      CATD     D(128)     Catalog header.
C      CATH     R(256)     Catalog header.
C      CATR     R(256)     Catalog header.
C      MKSJD    D          Scan start time (Jul day no).
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER RTYPES(10)*8, TYPES(7)*8, UNITS*8
      INTEGER   I, NAXIS, NRAN, NDIM(7), INDEX
      REAL      CRINC(7), CRPIX(7)
      DOUBLE PRECISION CRVAL(7)
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'MKINP.INC'
      INCLUDE 'MK4TAB.INC'
C
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
C                                        No. random parameters.
      DATA NRAN /8/
C                                        Rand. parm. names.
      DATA RTYPES /'UU-L-SIN','VV-L-SIN','WW-L-SIN',
     *   'TIME1   ','BASELINE','SOURCE  ','FREQSEL',
     *   'INTTIM  ','WEIGHT','SCALE'/
C                                       Uniform axes.
C                                        No. axes.
      DATA NAXIS /6/
C                                        Axes names.
      DATA TYPES /'COMPLEX ','FREQ    ','STOKES  ',
     *   'IF      ','RA      ','DEC     ','        '/
C                                        Axis dimensions
      DATA NDIM /3,1,1,1,1,1,0/
C                                        Reference values
      DATA CRVAL /1.0D0, -1.0D0, 0.0D0, 1.0D0, 3*0.0D0/
C                                        Reference pixel.
      DATA CRPIX /1.0, 1.0, 5*1.0/
C                                        Coordinate increment.
      DATA CRINC /1.0, -1.0, 0.0, 1.0, 1.0, 1.0, 0.0/
C                                       Units
      DATA UNITS /'CORREL. '/
C-----------------------------------------------------------------------
C                                       Zero fill CATBLK
      CALL FILL (256, 0, CATBLK)
C                                       Fill axis arrays.
C                                       Random axis names
      DO 10 I = 1,KIPTPN
         INDEX = KHPTP + (I-1) * 2
         CALL CHR2H (8, '        ', 1, CATH(INDEX))
 10      CONTINUE
C                                       Compressed data?
      IF (DOUVC) THEN
         NRAN = 10
         KLOCWT = 8
         NDIM(1) = 1
      ELSE
         NRAN = 8
         KLOCWT = -1
         NDIM(1) = 3
         END IF
C                                       Reference pixel for freq is
C                                       either 1 or middle of the
C                                       spectrum.
C                                       Fix later when we can split
C                                       sidebands!
      IF (IFSIDE(1,1).EQ.1) THEN
         CRPIX(2) = 1
      ELSE IF (IFSIDE(1,1).EQ.0) THEN
         CRPIX(2) = MKAFRQ(1)/2+1
      ELSE IF (IFSIDE(1,1).EQ.-1) THEN
         CRPIX(2) = MKAFRQ(1)+1
         END IF
C                                       Actual random parameters.
      DO 20 I = 1,NRAN
         INDEX = KHPTP + (I-1) * 2
         CALL CHR2H (8, RTYPES(I), 1, CATH(INDEX))
 20      CONTINUE
C                                       Uniform axes
      DO 30 I = 1,KICTPN
C                                       Init dimension
         CATBLK(KINAX+I-1) = NDIM(I)
C                                       Init. increment.
         CATR(KRCIC+I-1) = CRINC(I)
C                                       Init. rotation.
         CATR(KRCRT+I-1) = 0.0
C                                       Init. ref pixel.
         CATR(KRCRP+I-1) = CRPIX(I)
C                                       Init. ref value.
         CATD(KDCRV+I-1) = CRVAL(I)
C                                       Fill axis type from
C                                       TYPES
         INDEX = KHCTP + (I-1) * 2
         CALL CHR2H (8, TYPES(I), 1, CATH(INDEX))
 30      CONTINUE
C                                       Fill in values.
C                                       Fill other character strings.
C                                       Set number of axes.
      CATBLK(KIDIM) = NAXIS
      CATBLK(KIPCN) = NRAN
C                                       User ID
      CATBLK(KIIMU) = NLUSER
C                                       Miscellaneous items.
C                                       Epoch for Header???
      CATR(KREPO) = DEPOCH(1)
C                                       Convolving beam
      CATR(KRBMJ) = 0.0
      CATR(KRBMN) = 0.0
      CATR(KRBPA) = 0.0
      CATBLK(KINIT) = 0
C                                       Max. min.
      CATR(KRDMX) = 0.0
      CATR(KRDMN) = 0.0
C                                       Shift
      CATR(KRXSH) = 0.0
      CATR(KRYSH) = 0.0
C                                       "Old" (observed) position.
      CATD(KDORA) = 0.0D0
      CATD(KDODE) = 0.0D0
C                                       Rest Frequency
      CATD(KDRST) = 0.0D0
C                                       Alternate ref. value & pixel
      CATD(KDARV) = 0.0D0
      CATR(KRARP) = 0.0
      CATBLK(KIALT) = 0

C                                       Sort order ('**'=>unsorted)
      CALL CHR2H (2, '**', 1, CATH(KITYP))
C                                       Magic value blanking.
      CATR(KRBLK) = 0.0
C                                       Units
      CALL CHR2H (8, UNITS, 1, CATH(KHBUN))
C-----------------------------------------------------------------------
C                                       MKAFRQ = Number of freq chan.
C                                       MKNPOL = number of polarization
C                                           correlators.
C                                       OBSDAT = Reference date of time
C                                         tags for data as "yyyymmdd"
C                                       Insert values in header.
C                                       Number of vis. (Init. 10000)
      CATBLK(KIGCN) = 10000
C                                       Position.
      CATD(KDCRV+4) = 0.0D0
      CATD(KDCRV+5) = 0.0D0
C                                       Number of polarizations.
      IF (MKNPOL.GT.0) THEN
         CATBLK(KINAX+2) = MKNPOL
      ELSE
         MSGTXT = 'MK4HED:STOKES (OR FREQCODE) INADEQUATELY SPECIFIED'
         IRET = 5
         GO TO 990
         END IF
C                                       Stokes parameter observed.
      CATD(KDCRV+2) = -MKPOL1
C                                       Frequency - lowest IF, 1st FQID
      CATD(KDCRV+1) = DTAFQT(1,1)
C                                       Channel bandwidth - get from IF
C                                       bandwidth and number of
C                                       channels. For now assume all the 
C                                       same!
      CATR(KRCIC+1) = BWIFS(1) / MKAFRQ(1)
C                                       Number of frequencies.
      CATBLK(KINAX+1) = MKAFRQ(1)
C                                       Number of IFS.
      IF (MKAIF.LE.MAXIF) THEN
         CATBLK(KINAX+3) = MKAIF
      ELSE
         MSGTXT = 'MK4HED: EXCEED MAXIMUM NUMBER OF IFS'
         IRET = 5
         GO TO 990
         END IF
C                                       Observing date.
      CALL CHR2H (8, REFDAY, 1, CATH(KHDOB))
C                                       Object.
      CALL CHR2H (8, 'MULTI   ', 1, CATH(KHOBJ))
C                                       Telescope.
      CALL CHR2H (8, 'VLBI    ', 1, CATH(KHTEL))
C                                       Receiver
      CALL CHR2H (8, 'MKIV    ', 1, CATH(KHINS))
C                                       Observer's name.
      CALL CHR2H (8, 'Bonn Cor', 1, CATH(KHOBS))
C
C                                       Finished.
      IRET = 0
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
      END
      SUBROUTINE MK4CRE (IRET)
C-----------------------------------------------------------------------
C   Creates the output file
C   Output:
C      IRET     I     Return error code, 0=>OK, else failed.
C   Input from common
C      KHDOB    H(2)       Observation date in format ('DD/MM/YY').
C      KHIMC    H(2)       Image class (6 characters).
C      KHIMN    H(3)       Image name (12 characters).
C      KHPTY    H          Map physical type ('MA','UV').
C      KIGCN    I          No of random parm groups (uv vis records)
C      KIIMS    I          Image sequence number.
C   Input/output via common
C      BUFFER   R(UVBFSS)  Work buffer.
C      CLAOUT   C*6        Output file type.
C      NAMOUT   C*12       Output file name.
C      SEQOUT   I          Output file sewquence number.
C      DISKO    I          Output disk number.
C      CNOOUT   I          Output file sequence number.
C      FCNO     I(128)     Catalog slot nos of the marked files.
C      FRW      I(128)     R/W flags for marked catalog files.
C      FVOL     I(128)     Disk nos of the marked cat files.
C      NCFILE   I          No of catalog files marked.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      CHARACTER NAME*12, CLASS*6
      INCLUDE 'MK4IN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Get naming defaults
      NAME = 'MKIV DATA   '
      CLASS = '      '
      CALL MAKOUT (NAME, CLASS, 0, CLASS, NAMOUT, CLAOUT, SEQOUT)
      CALL CHR2H (12, NAMOUT, KHIMNO, CATH(KHIMN))
      CALL CHR2H (6, CLAOUT, KHIMCO, CATH(KHIMC))
C                                       File type ='UV'
      CALL CHR2H (2, 'UV', KHPTYO, CATH(KHPTY))
      CATBLK(KIIMS) = SEQOUT
      FSTVIS = 0
C                                       Create output file.
      CNOOUT = 1
      CALL UVCREA (DISKO, CNOOUT, BUFFER, IRET)
C                                       UVCREA error check.
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1003) IRET
         GO TO 990
         END IF
C                                       Mark in /CFILES/
      NCFILE = NCFILE + 1
      FVOL(NCFILE) = DISKO
      FCNO(NCFILE) = CNOOUT
      FRW(NCFILE) = 1
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1003 FORMAT ('ERROR',I3,' CREATING OUTPUT FILE')
      END
      SUBROUTINE MK4FQ (IRET)
C--------------------------------------------------------------------
C   Write the FQ table.
C   Output parameters:
C     IRET    I     Return code (<> 0 = error).
C   Input from common
C      DTAFQT   D(ifid#,if#) Set of AIPS IF frequencies for each
C                            IF if#. Each set of frequencies is
C                            identified by the IF id ifid# (Hz)
C      NTAFQT   I            No of entries in ITNAFQ.
C      REFREQ   D          Reference frequency (Hz) in catalog hdr.
C      BWIFS    R(ifid)    Bandwidth of IFs in each FQ id
C      ITNAFQ   I(ifid#)   No of IFs in each frequency set.
C      IFSIDE   I(ifid#,if#) Sideband of each IF in each FQ set
C      MKAFRQ   I(ifid#)   No of frequency channels per spectrum per FQ
C                          id. (Should all be the same in this vers)
C      MKAIF    I          Number of IF's in output file.
C   Input/output via common
C      BUFFER   R(UVBFSS)  Work buffer.
C      CNOOUT   I          Output file sequence number.
C      DISKO    I          Output disk number.
C      CATBLK   I(256)     Catalog header.
C      MSGTXT   C*80       AIPS message string.
C      FQKOLS   I(10)      FQ table column pointer array.
C      FQNUMV   I(10)      FQ table element count in each column.
C      IFQRNO   I          Next row number in FQ table.
C--------------------------------------------------------------------
      INTEGER IRET
C
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'MKINP.INC'
      INCLUDE 'MK4TAB.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
C
      DOUBLE PRECISION DIFFRQ(MXM4FQ)
      REAL CHWIF(MXM4FQ), TBWIF(MXM4FQ), BANDWD, CHW
      INTEGER ILUN, IVER, NUMIF, IFQAID, IFNO
C
      DATA ILUN /27/
C
C                                       Skip if no FQ entries.
      IF (NTAFQT .LE. 0) GO TO 999
C                                       Open FQ table for write.
      IVER = 1
      NUMIF = MKAIF
      CALL FQINI ('WRIT', BUFFER, DISKO, CNOOUT, IVER, CATBLK, ILUN,
     *   IFQRNO, FQKOLS, FQNUMV, NUMIF, IRET)
      IF (IRET .NE. 0) GO TO 990
      IFQRNO = 1
C                                       Loop over the AIPS freq. tables.
      DO 200 IFQAID = 1,NTAFQT
         BANDWD = BWIFS(IFQAID)
         CHW = BANDWD / MKAFRQ(IFQAID)
         NUMIF = ITNAFQ(IFQAID)
C                                       Fill the FQ table record.
         DO 100 IFNO = 1,NUMIF
            DIFFRQ(IFNO) = DTAFQT(IFQAID,IFNO) - REFREQ
            CHWIF(IFNO) = CHW
            TBWIF(IFNO) = BANDWD
C                                       No indication of LSB to TABFQ
            IFSIDE(IFQAID,IFNO) = ABS(IFSIDE(IFQAID,IFNO))
100         CONTINUE
C                                       Write the FQ table entry.
C            write(*,*) IFQRNO, FQKOLS, FQNUMV, NUMIF, IFQAID, DIFFRQ,
C     $         CHWIF, TBWIF, IFSIDE(IFQAID,1),IFSIDE(IFQAID,2)
         CALL TABFQ ('WRIT', BUFFER, IFQRNO, FQKOLS, FQNUMV,
     *      NUMIF, IFQAID, DIFFRQ, CHWIF, TBWIF, IFSIDE(IFQAID,1), IRET)
         IF (IRET .NE. 0) GO TO 990
C
200   CONTINUE
C                                       Close the FQ table.
      CALL TABFQ ('CLOS', BUFFER, IFQRNO, FQKOLS, FQNUMV, NUMIF,
     *   IFQAID, DIFFRQ, CHWIF, TBWIF, IFSIDE, IRET)
      IF (IRET .NE. 0) GO TO 990
      GO TO 999
C                                       Error handling.
990   WRITE (MSGTXT,1020) IRET
      CALL MSGWRT (8)
C                                       Exit.
999   RETURN
C--------------------------------------------------------------------
1020  FORMAT ('MK4FQ: Error ',I3,' writing FQ table')
      END
      SUBROUTINE MK4TB 
C-----------------------------------------------------------------------
C   MK4TB creates and fills a history file. Also write AN table
C
C   Input from common
C      HISCRD   C(10)*64   History records.
C      INFILE   C*48       Input file name.
C      REFDAY   C*8        Reference day ('yyyyddmm').
C      RLSNAM   C*8        Release name.
C      KHOBS    H(2)       Observer name.
C      KHTEL    H(2)       Telescope name (eg 'VLA').
C      KIGCN    I          No of random parm groups (uv vis records)
C      APARM    R(10)      AIPS input parameter values.
C      NUMHIS   I          Number of history records.
C      NLUSER   I          User number.
C   Input/output via common
C      BUFFER   R(UVBFSS)  Work buffer.
C      CLAOUT   C*6        Output file type.
C      NAMOUT   C*12       Output file name.
C      CNOOUT   I          Output file sequence number.
C      DISKO    I          Output disk number.
C      SEQOUT   I          Output file sewquence number.
C      CATBLK   I(256)     Catalog header.
C      CATH     R(256)     Catalog header.
C      ATSEL    R(2)       Input time range wrt ref Jul day no.
C                          (1=start time; 2=stop time).
C      MSGTXT   C*80       AIPS message string.
C      TSKNAM   C*6        AIPS task name.
C-----------------------------------------------------------------------
      CHARACTER HILINE*72, LABEL*8, ATIME*8, ADATE*12, TELE*8, OBSR*8
      INTEGER   LUN, I, IERR, TIME(3), DATE(3)
      LOGICAL   T
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'MKINP.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DHIS.INC'
      DATA LUN /27/
      DATA T /.TRUE./
C-----------------------------------------------------------------------
C                                       Write History.
      CALL HIINIT (3)
C                                       Create/open hist. file.
      CALL HICREA (LUN, DISKO, CNOOUT, CATBLK, BUFFER, IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,1000) IERR
         CALL MSGWRT (6)
         GO TO 999
         END IF
C                                       Get current date/time.
      CALL ZDATE (DATE)
      CALL ZTIME (TIME)
      CALL TIMDAT (TIME, DATE, ATIME, ADATE)
C                                       Write first record.
      WRITE (HILINE,1010) TSKNAM, NLUSER, ADATE, ATIME
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       New history
      WRITE (HILINE,1011) TSKNAM, INFILE
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
      CALL HENCOO (TSKNAM, NAMOUT, CLAOUT, SEQOUT, DISKO, LUN,
     *   BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Number of visibilities
      WRITE (HILINE,2001) TSKNAM, CATBLK(KIGCN)
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Telescope, observer name.
      CALL H2CHR (8, 1, CATH(KHTEL), TELE)
      CALL H2CHR (8, 1, CATH(KHOBS), OBSR)
      WRITE (HILINE,2002) TSKNAM, TELE, OBSR
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       AIPS release
      WRITE (HILINE,2003) TSKNAM, RLSNAM
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                       Reference date
      WRITE (HILINE,2004) TSKNAM, REFDAY
      CALL HIADD (LUN, HILINE, BUFFER, IERR)
      IF (IERR.NE.0) GO TO 200
C                                      Add any other history.
      IF (NUMHIS.GT.0) THEN
         WRITE (LABEL,1050) TSKNAM
         DO 50 I = 1,NUMHIS
            HILINE = LABEL // HISCRD(I)
            CALL HIADD (LUN, HILINE, BUFFER, IERR)
            IF (IERR.NE.0) GO TO 200
 50         CONTINUE
         END IF
C                                       Close HI file
 200  CALL HICLOS (LUN, T, BUFFER, IERR)
C                                       Print corr. parameters.
      CALL PRTPAR
C                                       Write ANtenna file.
      CALL MK4ANT( IERR )       
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,2019) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Write FQ table
      CALL MK4FQ (IERR)
      IF (IERR.NE.0) THEN
         WRITE (MSGTXT,2020) IERR
         CALL MSGWRT (8)
         GO TO 999
         END IF
C                                       Update CATBLK.
      CALL CATIO ('UPDT', DISKO, CNOOUT, CATBLK, 'REST', BUFFER, IERR)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MK4TB: ERROR',I3,' CREATE/OPEN HISTORY FILE')
 1010 FORMAT (A6,'/ Image created by user',I5,' at ',A12,2X,A8)
 1011 FORMAT (A6,'INFILE =''',A,'''')
 1050 FORMAT (A6,' /')
 2001 FORMAT (A6,' / Number of visibilities copied=',I9)
 2002 FORMAT (A6,' / Telescope = ',A8,' Observer = ',A8)
 2003 FORMAT (A6,' Release = ''',A7,' ''')
 2004 FORMAT (A6,' REFDATE = ''',A8,' '' / Reference day for times')
 2019 FORMAT ('MK4TB: ERROR',I3,' WRITING AN TABLE')
 2020 FORMAT ('MK4TB: ERROR',I3,' WRITING FQ TABLE')
      END
      SUBROUTINE PRTPAR  
C-----------------------------------------------------------------
C   Print the correlator model parameters at the end of the run
C   if required.
C   Input from common
C      DTACLK   D(ant#)    Station clock rate (us/s) >0 = fast.
C      DTAEPO   D(ant#)    Station clock epoch (s since REFDAY).
C      DTALOC   D(3,ant#)  X,Y,Z coordinates for antenna ant# using
C                          right-handed axes.
C      DTASYN   D(ant#)    Station clock offset (us) >0 = fast.
C      DBLANK   D          Magic value (= indeterminate).
C      ANTNAM   C*8(ant#)  Antenna name.
C      MKPRNT   I          Print level (0..4).
C      NANT     I          No of antennas in antenna list.
C      ATJDRF   D          Reference Jul day no for output file.
C      DTGAST   D          GAST at 0 UT on refday (deg).
C      DTSIDD   D          d(GAST)/d(UT) on refday (deg/day)
C      DTUT1    D          UT1-UTC (s) on refday.
C      DTWOB    D(2,day#)  X(=1),Y(=2) pole posn on day# (arcsec).
C      DTVLIG   D          Speed of light value for run (m/s).
C   Input/output via common
C      MSGTXT   C*80       AIPS message string.
C-----------------------------------------------------------------
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'MKINP.INC'
      INCLUDE 'MKSTA.INC'
C      INCLUDE 'MKCHR.INC'
      INCLUDE 'MK4TAB.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
C
      INTEGER I
      REAL BADDAT
      CHARACTER*15 DMS, HMS, CRAEPO, CECEPO, CRAAPP, CECAPP
C----------------------------------------------------------------------
C                                       Check print level.
      IF (MKPRNT .LE. 0) GO TO 999
C                                       Print header
      WRITE (MSGTXT,1000)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1025) REFJD
      CALL MSGWRT (6)
C                                       Run parameters.
      WRITE (MSGTXT,1030)
      CALL MSGWRT (6)
C
      WRITE (MSGTXT,1040) RDOY, DTUT1, DTGAST, DTSIDD, DTWOB(1),
     *   DTWOB(2) 
      CALL MSGWRT (6)
      CONTINUE
C                                       Antenna clocks.
      WRITE (MSGTXT,1045)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1050)
      CALL MSGWRT (6)
      DO 50 I = 1,NANT
         WRITE (MSGTXT,1060) ANTNAM(I), MNTANT(I),
     *      (DTAEPO(I)/86400.)+RDOY, DTASYN(I), DTACLK(I) 
         CALL MSGWRT (6)
50       CONTINUE
C                                       Source info
      WRITE (MSGTXT,1070)
      CALL MSGWRT (6)
      WRITE (MSGTXT,1075)
      CALL MSGWRT (6)
      DO 60 I = 1,NSOUR
         CRAEPO = HMS(DRAEPO(I),3)
         CECEPO = DMS(DECEPO(I),4)
         CRAAPP = HMS(DRAAPP(I),3)
         CECAPP = DMS(DECAPP(I),4)
         WRITE (MSGTXT,1080) SULIST(I), CRAEPO, CECEPO, CRAAPP, CECAPP 
         CALL MSGWRT (6)
 60      CONTINUE
C                                       Percentage of good/bad data
      BADDAT =  BADWT/(BADWT+GODWT)*100.D0
      WRITE (MSGTXT,1100) BADDAT
      CALL MSGWRT (6)
C                                       Number of solutions 
      WRITE (MSGTXT,1110) TOTSOL, BADSOL
      CALL MSGWRT (6)
C                                       Exit
999   RETURN
C--------------------------------------------------------------------
1000  FORMAT ('CORRELATION PARAMETERS and PRECESSED POSITIONS')
1020  FORMAT ('Speed of light (m/s): ', D17.10)
1025  FORMAT ('Reference Julian day: ',F10.1)
1030  FORMAT ('DOY   UT1-UTC',2X,'GAST (deg)',2X,
     *   'GAST dot rad/s',2X,'X,Y pole (arc s)')
1040  FORMAT (I4,2X,F7.4,2X,F10.4,2X,E14.7,2X,F7.4,2X,F7.4)
1045  FORMAT ('Station Clocks')
1050  FORMAT ('Antenna',4X,'Epoch (days)',6X,'Offset (us)',
     *   7X,'Rate (us/s)')
1060  FORMAT (A8,2X,I2,2X,F11.6,1X,F14.4,3X,D12.5)
1070  FORMAT ('Source Info')
1075  FORMAT ('Source ',3X,'RA (J2000)',3X,'DEC (J2000)',
     *   3X,'RA (APP)  ',3X,'DEC (APP) ')
1080  FORMAT (A8,2X,2(A12,1X,A13,1X))
1100  FORMAT ('Percentage of data rejected due to WTTHRES: ', F6.2)
1110  FORMAT ('Total # of solutions transfered:',I6,' of which',I5,
     *   ' were bad' )
      END
      SUBROUTINE MK4XPN (LUN, NVS, IRET)
C-----------------------------------------------------------------------
C   Expands AIPS output file.
C   Input:
C      LUN      I  LUN of file
C      NVS      I  Total number of vis wanted in file
C   Output:
C      IRET     I  Return code, 0=>OK, else failed
C   Input from common
C      LREC     I          Length in values of a visibility record.
C   Input/output via common
C      OFILE    C*48       Physical file name for output file.
C      FILSIZ   I          Output file size.
C      DISKO    I          Output disk number.
C-----------------------------------------------------------------------
      INTEGER   LUN, NVS, IRET
C
      INTEGER  NREC
      INCLUDE 'MK4IN.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
C-----------------------------------------------------------------------
C                                       Expand file
      NREC = (((NVS - FILSIZ) * LREC * 2) / 512) + 1
      IF (NREC.GT.0) THEN
         CALL ZEXPND  (LUN, DISKO, OFILE, NREC, IRET)
         IF (IRET.NE.0) GO TO 999
         END IF
C                                       Get new file size
      CALL ZEXIST (DISKO, OFILE, FILSIZ, IRET)
      FILSIZ = (FILSIZ * 256.0D0) / LREC
C
 999  RETURN
      END
      SUBROUTINE MK4DAT (U, V, W, T, IA1, IA2, IAREF, IFQAID,
     *   VIS, RPARM, IRET)
C-----------------------------------------------------------------------
C   Gets all the cross-spectra for 1 baseline for 1 time and passes them
C   in array VIS. Calls CRSPEC to get a single cross spectrum at a time.
C   All spectra for all stokes and IFs are filled into TVIS. Weights of
C   0 indicate no or bad data. Cross-spetra are always double-sideband,
C   reference frequency in the middle. From the OVEX file we know whether
C   the lower sideband has to be discarded.
C   When IRET of CRSPEC is -10 GETSOL has to be called to get solutions
C   for this scan/baseline.
C   
C   Output:
C      U       R       U in wavelengths at the reference frequency.
C      V       R       V in wavelengths
C      W       R       W in wavelengths
C      T       R       Time in days since the midnight at the start of
C                      the reference date.
C      IA1     I       Antenna number of the first antenna.
C      IA2     I       Antenna number of the second antenna.
C                      NOTE: IA2 MUST be greater that IA1
C      IAREF   I       Ref antenna (ie one NOT fringe rotated)
C                      1=stn A; 2=stn B. Default is 1 for MKIV.
C      IFQAID  I       Frequency id.
C      RPARM   R       Modified random parameter array. NB U,V,W,
C                      time and baseline should not be modified in RPARM
C      VIS     R(3,*)  Visibilities.
C      IRET    I       Return code  -1 => End of data;
C                             0 => OK
C                            >0 => error, terminate.
C                           -10 => get solutions for scan/baseline  
C   Input from common
C      FBLANK   R          REAL value indicating blanking.
C      ICOR0    I          Value of first Stokes value.
C      INCIF    I          Increment in data for IF.
C      IATOFF   R          IAT-UTC (seconds).
C      INCS     I          Increment in data for Stokes.
C      LREC     I          Length in values of a visibility record.
C      DOUVC    L          Compress output file ?
C      KINAX    I(7)       Number of pixels on each axis.
C      MKAFRQ   I          No of freq channels per spectrum in
C                          output file.
C      MKAIF    I          Number of IF's in output file.
C      NRPARM   I          Number of random parameters.

C   Input/output via common
C      CURSOU   I          Current source number in SU table.
C      CURINT   R          Data integration time (seconds)
C      MSGTXT   C*80       AIPS message string.
C      JLOCS    I          Order in data of Stokes parameters.
C      NSCANS   I          Number of scans in this observation
C      STRSCN   D(#scans)  Start time of scans
C      STPSCN   D(#scans)  Stop time of scans
C      SCNDON   I(#scans)  Status of scans for CL table
C-----------------------------------------------------------------------
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'MKSTA.INC'
      INCLUDE 'MK4TAB.INC'
      INCLUDE 'MKINP.INC'
      INCLUDE 'MKSCN.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DANT.INC'
C
      INTEGER   IA1, IA2, IRET, IFQAID, IAREF, ISTOKE, IP, I, J,
     *   JNCIF, JNCS, STKOFF, NCOPY, FQID, ISTOKN
      REAL      U, V, W, T, VIS(3,*), RPARM(*), CURINN, RS
C
      INTEGER   MXTVIS, IA1N, IA2N, CSPLG, CRSLGT, ICHNL, ICHNH, IFNO,
     *   CURSON, ZT(3), ISCAN, IERR, IFNN, NMESSA
C                                       16 IFs, 4 polarizations,  
C                                       2048 channels per baseline
C                                       maximum (= 65,536*2)
      PARAMETER (CSPLG = 2048)
      PARAMETER (MXTVIS = 16 * 4 * CSPLG)
      REAL      TVIS(3,MXTVIS), CROSSP(3,CSPLG)
      LOGICAL   FIRST, GOT
      DOUBLE PRECISION TUTC, TUTCN, IATADD
      SAVE FIRST, TUTC, TUTCN, IA1N, IA2N, TVIS, ISTOKE, CROSSP, NCOPY,
     *   IFNO, CURSON, CURINN, IATADD, FQID, ISTOKN, IFNN, NMESSA
C                                       FQID probably only needed for
C                                       S/X 
      LOGICAL ANTCLD(MAXANT,MXFQID)
      SAVE ANTCLD
C#####################################################################
C                                       Correct Haystack amp by 44200
C                                       which is (32-1)/(8-1)*10000
C                                       This is still about 5.3% low
      REAL FAKTOR
C#####################################################################
      DATA NMESSA /0/
C-----------------------------------------------------------------------
C                                       Startup ? 
      IF (IA1.EQ.0 .AND. IA2.EQ.0 ) THEN 
         FIRST = .TRUE.
         GOT = .FALSE.
C#####################################################################
         FAKTOR = (8.-1.)/(32.-1.)*1.E-4 
C#####################################################################
         IF (TIMSYS .EQ. 'IAT' ) THEN
            IATADD = IATOFF/86400.0D0
         ELSE
            IATADD = 0.D0
            END IF
         BADWT = 0.D0
         GODWT = 0.D0
         DO 10 I = 1, NSCANS
            SCNDON(I) = 0
 10         CONTINUE
      ELSE
         FIRST = .FALSE.
         END IF  

C                                       Set to zero
      DO 30 I = 1,MXTVIS
         TVIS(1,I) = 0.0
         TVIS(2,I) = 0.0
         TVIS(3,I) = 0.0
 30      CONTINUE
C
      IRET = 0
C                                       Store away spectrum from
C                                       previous round. Was new
C                                       visibility.
      IF (GOT) GO TO 110
C                                       Loop for getting cross spectra
 50   CONTINUE
C                                       Call to get the cross spectrum
C                                       data. We get a spectrum in each
C                                       CALL. We have to get all spectra
C                                       for all IFs and all stokes to
C                                       create an AIPS visibility.
C                                       TUTC is beginnig of AP.
      CALL CRSPEC (CSPLG, TUTCN, IA1N, IA2N, IAREF, IFNN, CURSON,
     *   CURINN, ISTOKN, FQID, CROSSP, CRSLGT, IRET)
      IF (IRET.GT.0) THEN
         WRITE (MSGTXT,1010) IRET
         GO TO 990
         END IF
C                                       The previous was the last one
      IF (IRET.EQ.-1) THEN
C            write(*,*)'The END is near'
         IF (NMESSA.GT.0) THEN
            WRITE (MSGTXT,1015)   
            CALL MSGWRT (5)
            END IF
         GOTO 500
         ENDIF
C                                       Get solutions
      IF (IRET.EQ.-10 .AND. DOBS .AND. IA1N.NE.IA2N ) THEN
         CALL MKSOLN (CURINN, IERR)
         IF (IERR.GT.0) THEN
            WRITE (MSGTXT,1013) IERR
            GO TO 990
            END IF
         ENDIF
C                                      Do some checks
      IF (CRSLGT.NE.2*MKNLAG) THEN
         WRITE (MSGTXT,1011) CRSLGT/2
         GO TO 990
         END IF
C                                       Check various quantities 
      IF (IA1N.LT.1 .OR. IA1N.GT.NANT .OR. IA2N.LT.1 .OR. IA2N.GT.NANT)
     *   THEN
         WRITE (MSGTXT,1100) IA1N, IA2N
         IRET=99
         END IF
      IF (IFNN.LT.1 .OR. IFNN.GT.MKAIF) THEN
         WRITE (MSGTXT,1101) IFNN
         IRET=99
         END IF
      IF (ISTOKN.LT.MKPOL1 .OR. ISTOKN.GT.MKPOL2) THEN
         WRITE (MSGTXT,1102) ISTOKN
         IRET=99
         END IF
C
C                                       This visibility is finished?
C                                       Then write it out.
      IF (.NOT.FIRST .AND. (TUTC.NE.TUTCN .OR.
     $      IA1.NE.IA1N .OR. IA2.NE.IA2N .OR. IFQAID.NE.FQID)) GO TO 500
C                                       Where should this be stored in
C                                       TVIS? Calculate pointers.
C                                       AIPS Stokes pointer. 
 110  IA1 = IA1N
      IA2 = IA2N
      TUTC = TUTCN
      IFNO = IFNN
      CURINT = CURINN
      ISTOKE = ISTOKN     
      CURSOU = CURSON
      IFQAID = FQID
      FIRST = .FALSE.
      JNCIF = INCIF / CATBLK(KINAX)
      JNCS = INCS / CATBLK(KINAX)
      STKOFF = (ABS (-ISTOKE - ICOR0)) * JNCS
C                                       Start pointer for AIPS array.
      IP = 1 + (IFNO-1) * JNCIF + STKOFF
C      call t2dhms( real(tutc),1,zt,rs)
C      write(*,*)IP,IA1,IA2,IFNO,JNCIF,STKOFF,ISTOKE,ICOR0,JNCS,zt,rs
C                                       Check if double sideband. Number
C                                       of freqs should be the same for
C                                       all IFs, I guess, but let's see
C                                       later whether it can be more
C                                       flexible. 
      IF (IFSIDE(IFQAID,1).EQ.1) THEN
         ICHNL = 1 + MKAFRQ(IFQAID)
         ICHNH = MKAFRQ(IFQAID)*2 
      ELSE IF (IFSIDE(IFQAID,1).EQ.0) THEN
         ICHNL = 1
         ICHNH = MKAFRQ(IFQAID) 
      ELSE IF (IFSIDE(IFQAID,1).EQ.-1) THEN
         ICHNL = 1
         ICHNH = MKAFRQ(IFQAID)
         END IF
C
C      write(*,*) ICHNL,ICHNH
C      write(*,*)(CROSSP(1,J),CROSSP(2,J),CROSSP(3,J),J=ICHNL,ICHNH)
      DO 120 J = ICHNL,ICHNH
C                                       Do we have duplicate fourfit
C                                       files in a scan? Test is only of
C                                       limited use here, but it tests
C                                       other things as well....
         IF (TVIS(1,IP).NE.0. .OR. TVIS(2,IP).NE.0. .OR.
     *      TVIS(3,IP).NE.0.) THEN
            WRITE (MSGTXT,1020)
C**************                          Debug! Remove later
            CALL T2DHMS( REAL(TUTC),1,ZT,RS)
            WRITE (MSGTXT,1017) IA1, IA2, IFNO, ISTOKE, ZT, RS
C            WRITE(*,*) IP, IA1, IA2, IFNO, JNCIF, STKOFF, ISTOKE,
C     *         ICOR0, JNCS, ZT, RS, IFQAID
C**************
            GO TO 50
            END IF            
         IF (CROSSP(3,J) .GE. WTHRES) THEN 
            TVIS(1,IP) = CROSSP(1,J) *FAKTOR
            TVIS(2,IP) = CROSSP(2,J) *FAKTOR
            TVIS(3,IP) = CROSSP(3,J)
            GODWT = GODWT + 1.D0
         ELSE
            BADWT = BADWT + 1.D0
            END IF
         IP = IP + 1
 120     CONTINUE

C                                       Next spectrum for this
C                                       baseline for curr. visibility?  
      GO TO 50
C                                       Next visibility. End of loop
C
 500  CONTINUE
C                                       Time has to be shifted to center
C                                       of AP. IATADD = 0
      T = TUTC + IATADD + (CURINT/86400.0D0/2.0D0)
C                                       Compute U,V and W.
      CALL MK4UVW ( .NOT.GOT, T, IA1, IA2, IFQAID, U, V, W, IERR )
      IF (IERR.GT.0) THEN
         WRITE (MSGTXT,1014) IERR
         GO TO 990
         END IF
C                                       Remember that 1 was saved
      GOT = .TRUE.
C                                       Check AIPS baseline order
C      call t2dhms( t,1,zt,rs)
C      write(*,*)IA1,IA2,zt,rs,CURSOU, CURINT
      IAREF = 1
      IF (IA1.GT.IA2) THEN
         IF (NMESSA.LT.100) THEN
            WRITE (MSGTXT,1015)   
            CALL MSGWRT (5)
            NMESSA = NMESSA + 1
            IF (NMESSA.GE.100) THEN
               WRITE (MSGTXT,1016)   
               CALL MSGWRT (5)
               END IF
            END IF
C                                       Change ref station pointer
         IAREF = 2
         DO 150 I = 1,NIF
            IP = (I - 1) * JNCIF + 1
            CALL MK4FLP (NCHAN, NPOLN, ICOR0, JLOCS,
     *         TVIS(1,IP), TVIS(1,IP))
150         CONTINUE
         IP = IA1
         IA1 = IA2
         IA2 = IP
         U = -U
         V = -V
         W = -W
         END IF
C                                       Compressed data?
      NCOPY = LREC - NRPARM
      IF (DOUVC) THEN
         CALL ZUVPAK (NCOPY, TVIS, RPARM(1+KLOCWT), VIS)
      ELSE
         CALL RCOPY (NCOPY, TVIS, VIS)
         END IF
C
C                                       Check if we have to write
C                                       entries to the CL table...
C                                       First find which scan is it
      DO 200 I = 1, NSCANS
         IF (TUTC.GE.STRSCN(I) .AND. TUTC.LE.STPSCN(I)) THEN
            ISCAN = I
            GO TO 201
            ENDIF
 200     CONTINUE
C                                       New scan? Should check here for
C                                       time reversals as well...!!!
 201  IF (SCNDON(ISCAN).EQ.0) THEN
         SCNDON(ISCAN) = 1
C                                       Initialize antenna flag array
         DO 210 I = 1, NANT
            DO 210 J = 1, NTAFQT
               ANTCLD(I,J) = .FALSE.
 210        CONTINUE
         ENDIF
C                                       Check for first ant
      IF (.NOT.ANTCLD(IA1,IFQAID)) THEN
C                                       Write CL table for this ant and
C                                       this scan
C         write(*,*) 'Do aprioris for', STRSCN(ISCAN),STPSCN(ISCAN),IA1,
C     *      IFQAID
         CALL MK4CAL (ISCAN, IA1, IFQAID, IERR)
         IF (IERR.NE.0) GO TO 990
         ANTCLD(IA1,IFQAID) = .TRUE.
         ENDIF
C                                       2nd ant
      IF (.NOT.ANTCLD(IA2,IFQAID)) THEN
C                                       Write CL table for this ant and
C                                       this scan
C         write(*,*) 'Do aprioris for', STRSCN(ISCAN),STPSCN(ISCAN),IA2,
C     *      IFQAID
         CALL MK4CAL (ISCAN, IA2, IFQAID, IERR)
         IF (IERR.NE.0) GO TO 990
         ANTCLD(IA2,IFQAID) = .TRUE.
         ENDIF
C
      GO TO 999
C                                       Error message
 990  CALL MSGWRT(8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ERROR',I7,' Reading Cross Spectrum')
 1011 FORMAT ('ERROR. Got wrong cross spectrum size ',I5)
 1012 FORMAT ('Warning. Got wrong FQID ',I5)
 1013 FORMAT ('ERROR',I7,' dealing with solutions')
 1014 FORMAT ('ERROR',I7,' setting up UVW calculations')
 1015 FORMAT ('Warning: Baseline reversed. Damages spectral lines')
 1016 FORMAT ('Warning: Further printing of WARNING message suppressed')
 1017 FORMAT ('Warning: Duplicate data at ',7I3,F3.2)
 1020 FORMAT ('ERROR: probably duplicate data ')
 1100 FORMAT ('ERROR: Station IDs out of range:',2I5)
 1101 FORMAT ('ERROR: IF out of range:',I5)
 1102 FORMAT ('ERROR: Stokes out of range:',I5)
      END
      SUBROUTINE MK4FLP (NCHAN, NPOLN, IPOLRF, STORD, VIS, VIS2)
C-----------------------------------------------------------------------
C   Reverses a baseline.
C   Inputs:
C      NCHAN   I  Number of frequency channels.
C      NPOLN   I  Number of polarization channels (RR, LL, RL, LR)
C      IPOLRF  I  Ref Stokes value on polzn axis
C      STORD   I  Order of stokes axis, 1=> before freq
C   Input/Output
C      VIS     R(3,NPOLN,NCHAN)  Visibility data
C      VIS2    R(3,NCHAN,NPOLN)  Visibility data
C-----------------------------------------------------------------------
      INTEGER   NCHAN, NPOLN, STORD, IPOLRF
      REAL      VIS(3,NPOLN,NCHAN), VIS2(3,NCHAN,NPOLN)
C
      INTEGER   IFREQ, IPOLRL, IPOLLR, IP, K
      REAL      TEMP
C-----------------------------------------------------------------------
C                                       RL,LR pointers
      IPOLRL = IPOLRF + 4
      IPOLLR = IPOLRL + 1
C                                       Check data order
C                                       Polarization before frequency
      IF (STORD.NE.1) GO TO 500
C
      DO 200 IFREQ = 1,NCHAN
         DO 80 IP = 1,NPOLN
C                                       Conjugate data.
            VIS(2,IP,IFREQ) = -VIS(2,IP,IFREQ)
 80         CONTINUE
C                                       Swap RL,LR if present
         IF ((IPOLRL .GE. 1) .AND. (IPOLLR .LE. NPOLN)) THEN
            DO 100 K = 1,3
               TEMP = VIS(K,IPOLRL,IFREQ)
               VIS(K,IPOLRL,IFREQ) = VIS(K,IPOLLR,IFREQ)
               VIS(K,IPOLLR,IFREQ) = TEMP
 100           CONTINUE
            END IF
 200     CONTINUE
      GO TO 999
C                                       Frequency before polarization

 500  CONTINUE
      DO 600 IFREQ = 1,NCHAN
         DO 520 IP = 1,NPOLN
C                                       Conjugate data.
            VIS2(2,IFREQ,IP) = -VIS2(2,IFREQ,IP)
 520        CONTINUE
C                                       Swap RL,LR if present
         IF ((IPOLRL .GE. 1) .AND. (IPOLLR .LE. NPOLN)) THEN
            DO 550 K = 1,3
               TEMP = VIS2(K,IFREQ,IPOLRL)
               VIS2(K,IFREQ,IPOLRL) = VIS2(K,IFREQ,IPOLLR)
               VIS2(K,IFREQ,IPOLLR) = TEMP
 550           CONTINUE
            END IF
 600     CONTINUE
C                                       Exit
 999  RETURN
      END
      SUBROUTINE MK4ANT( IERR )
C-----------------------------------------------------------------------
C   MK4ANT creates and fills the antenna file.
C   Input from common
C      DTALOC   D(3,ant#)  X,Y,Z coordinates for antenna ant# using
C                          right-handed axes.
C      NANT     I          No of antennas in antenna list.
C      DTWOB    D(2)       X(=1),Y(=2) pole posn on refday (arcsec).
C      DTUT1    D          UT1-UTC (s) on REFDAY
C      IATOFF   R          IAT-UTC (seconds).
C      MKAIF    I          Number of IF's in output file.
C      DTGAST   D          GAST at 0 UT on refday (deg).
C      DTSIDD   D          d(GAST)/d(UT) on refday (deg/day).
C      FREQ     D          Frequency (Hz).
C      REFDAY   C*8        Reference day ('yyyymmdd').

C   Input/output via common
C      CLBUFF   R(UVBFSS)  Work buffer.
C      CNOOUT   I          Output file sequence number.
C      DISKO    I          Output disk number.
C      CATBLK   I(256)     Catalog header.
C      MSGTXT   C*80       AIPS message string.
C      DTJULD   D(day#)    Julian day no for run based parameters.
C-----------------------------------------------------------------------
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'MK4TAB.INC'
      INCLUDE 'MKSTA.INC'
C
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
      INTEGER   IERR, VER, LUN, NUMV(MAXANC), I, ANTNIF
      CHARACTER XYZHAN*8,TFRAME*8

C
      DATA LUN /27/
      DATA NUMV /8,3,0,1,1,1,1,1,3,1,1,3/
C-----------------------------------------------------------------------
C                                       Make sure there is antenna info
      IF (NANT.LE.0) GO TO 999
C                                       Setup for AN table initization
         NUMORB = 0
         NOPCAL = 2 * MKAIF
C                                       Reference day = 1st day of obs
         RDATE = REFDAY
C                                       Position of the earth's pole
         POLRXY(1) = DTWOB(1)
         POLRXY(2) = DTWOB(2)
         UT1UTC = DTUT1
         DATUTC = IATOFF
C                                       Array name
         ANAME = 'VLBI'
C                                       Array center (rel to center of
C                                       earth)
         ARRAYC(1) = 0.0D0
         ARRAYC(2) = 0.0D0
         ARRAYC(3) = 0.0D0
         XYZHAN = 'RIGHT'
         TFRAME = ' '
C      
         ANTNIF = 0
         DO 10 IFQAID = 1,NTAFQT
         ANTNIF = MAX( ITNAFQ(IFQAID), ANTNIF )
 10      CONTINUE
C                                       Get GST0 and Earth rotation rate
         GSTIA0 = DTGAST
         GSTIA0 = MOD (GSTIA0, 360.0D0)
         IF (GSTIA0 .LT. 0.0) GSTIA0 = GSTIA0 + 360.0D0
         DEGPDY = DTSIDD
         SAFREQ = FREQ
C                                       Number of values in each column
C                                       in the AN table.
         CALL COPY (12, NUMV, ANNUMV)
C                                       Polarization cal. columns
         ANNUMV(9) = 2 * MKAIF
         ANNUMV(12) = 2 * MKAIF
         ANFQID = -1
         VER = 1
C                                       Create/init file
         CALL ANTINI ('WRIT', CLBUFF, DISKO, CNOOUT, VER, CATBLK, LUN,
     *      IANRNO, ANKOLS, ANNUMV, ARRAYC, GSTIA0, DEGPDY, SAFREQ,
     *      RDATE, POLRXY, UT1UTC, DATUTC, TIMSYS, ANAME,XYZHAN, TFRAME,
     $      NUMORB, NOPCAL, ANTNIF, ANFQID, IERR)
         IF (IERR.NE.0) GO TO 990
C                                       init basic AN record
         ANNAME = '        '
         STAXOF = 0.0
         STAXYZ(1) = 0.0D0
         STAXYZ(2) = 0.0D0
         STAXYZ(3) = 0.0D0
         ORBPRM(1) = 0.0D0
         NOSTA = 0
         MNTSTA = 0
         POLAA = 0.0
         POLAB = 0.0
         CALL RFILL (ANNUMV(9), 0.0, POLCA)
         CALL RFILL (ANNUMV(12), 0.0, POLCB)
         POLTYA = 'R'
         POLTYB = 'L'
         IF (NANT.LE.0) GO TO 30
C                                       AN records
         IANRNO = 1
         DO 20 I = 1,NANT
            IF ( DTALOC(1,I) .NE. DBLANK ) THEN
               STAXYZ(1) = DTALOC(1,I)
               STAXYZ(2) = DTALOC(2,I)
               STAXYZ(3) = DTALOC(3,I)
               NOSTA = I
               ANNAME = ANTNAM(I)
               MNTSTA = MNTANT(I)
C                                       Fix Mount type. 
C                                       No orbiting antennas at present
C                                       Beware of XY mounts!!
               IF (MNTSTA .EQ. 3) MNTSTA = 0  
               IF (MNTSTA .EQ. 2 .OR. MNTSTA .EQ. 4) THEN
                  WRITE (MSGTXT,1010) MNTSTA 
                  CALL MSGWRT (3)
                  END IF
C
               STAXOF = ANTXOF(I)
               DIAMAN = 0.
C              FWHMAN ?????
               CALL TABAN ('WRIT', CLBUFF, IANRNO, ANKOLS, ANNUMV,
     *            ANNAME, STAXYZ, ORBPRM, NOSTA, MNTSTA, STAXOF,
     *            DIAMAN, FWHMAN, POLTYA, POLAA, POLCA, POLTYB, POLAB,
     $            POLCB, IERR)
               IF (IERR.NE.0) GO TO 990
            ELSE
               IANRNO = IANRNO + 1
               END IF
 20         CONTINUE
C                                       Close
 30      CALL TABIO ('CLOS', 1, IANRNO, CLBUFF, CLBUFF, IERR)
         IF (IERR.NE.0) GO TO 990
         GO TO 999
C                                       Error
 990  WRITE (MSGTXT,1020) IERR
      CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('ERROR. Found illegal mount type ',I3)
 1020 FORMAT ('ERROR ',I3,' OCCURED WRITING ANTENNA FILE')
      END
      SUBROUTINE MK4TEL (IRET)
C-----------------------------------------------------------------------
C   Look for user signals (TELL), at present only honor 'QUIT' and
C   'ABOR' .
C   Output
C      IRET   I  Return code, 0=> continue, <0=quit gracefully, >0=die.
C-----------------------------------------------------------------------
      INTEGER   IRET
C
      INCLUDE 'INCS:DMSG.INC'
      CHARACTER OPTELL*4
      INTEGER   NPARM, SBUFF(256), IERR
      REAL      DUMMY
C-----------------------------------------------------------------------
C                                       Check TELL file
      IRET = 0
      NPARM = 1
      CALL GTTELL (NPARM, OPTELL, DUMMY, SBUFF, IERR)
      IF (IERR.NE.0) THEN
         MSGTXT = 'Received ' // OPTELL // ' operation from TELL'
         CALL MSGWRT (4)
         END IF
      IF (IERR.EQ.2) IRET = -1
      IF (IERR.EQ.3) IRET = 9
C
 999  RETURN
      END
      SUBROUTINE MK4SOU(IRET)
C-----------------------------------------------------------------------
C   MK4SOU creates and fills the source file.
C   Output parameters:
C     IRET     I       Return code (0 = OK, <> 0 = Error).
C   Input from common
C      DBLANK   D          Magic value (= indeterminate).
C      KINAX    I(7)       Number of pixels on each axis.
C      KRCIC    R(7)       Coordinate value increment along axis.
C      CATR     R(256)     Catalog header.
C      SULIST   C(100)*16  Source list; NSOUR will be used
C
C   Input/output via common
C      CNOOUT   I          Output file sequence number.
C      DISKO    I          Output disk number.
C      CATBLK   I(256)     Catalog header.
C      IDSOUR   I(100)     SU table index: source number.
C      SUKOLS   I(50)      SU table column pointer array.
C      SUNUMV   I(50)      SU table element count in each column.
C      SUBUFF   I(1024)    SU table buffer.
C      ISURNO   I          Next scan number in SU table.
C-----------------------------------------------------------------------
      INTEGER IRET
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'MK4TAB.INC'
C
      DOUBLE PRECISION DFREQ0(MXM4FQ), DBANDW, ORAEPO, OECEPO, OEPOCH,
     *   ORAAPP, OECAPP, DLSRV(MXM4FQ), DRSTFQ(MXM4FQ), DPMRA, DPMDC
      REAL FLUX(4,MXM4FQ)
      INTEGER K, M, IVER, ILUN, INOGRP, IRECNO, LSUFQD, IDSOU, IQUAL
      CHARACTER LVETYP*8, LVEDEF*8, LSUNAM*16, LCALCD*4
C
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DFIL.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DUVH.INC'
C--------------------------------------------------------------------
C                                       Initialisation
      IRET = 0
C
      IVER = 1
      ILUN = 28
      INOGRP = MKAIF
      LVETYP = '        '
      LVEDEF = '        '
      CALL SOUINI ('WRIT', SUBUFF, DISKO, CNOOUT, IVER, CATBLK,
     *   ILUN, INOGRP, LVETYP, LVEDEF, LSUFQD, ISURNO, SUKOLS, SUNUMV,
     *   IRET)
      IF (IRET .NE. 0) GO TO 999
C
C                                       Loop for table entries
      DO 300 IDSOU = 1, NSOUR
C                                       Create new SU table entry.
         DO 250 K = 1, INOGRP
            DO 200 M = 1, 4
               FLUX(M,K) = 0.0
 200           CONTINUE
            DFREQ0(K) = 0.0D0
            DLSRV(K) = 0.0D0
            DRSTFQ(K) = 0.0D0
 250        CONTINUE
C
         IQUAL = 0
         LCALCD = '    '
C                                       Coordinates
         ORAEPO = DRAEPO(IDSOU)
         OECEPO = DECEPO(IDSOU)
         OEPOCH = DEPOCH(IDSOU)
         ORAAPP = DRAAPP(IDSOU)
         OECAPP = DECAPP(IDSOU)
C                                       Bandwidth per channel
         DBANDW = CATR(KRCIC + JLOCF)
         IRECNO = IDSOU
         LSUNAM = SULIST(IDSOU)
         CALL TABSOU ('WRIT', SUBUFF, IRECNO, SUKOLS, SUNUMV,
     *      IDSOU, LSUNAM, IQUAL, LCALCD, FLUX, DFREQ0, DBANDW,
     *      ORAEPO, OECEPO, OEPOCH, ORAAPP, OECAPP, DLSRV, DRSTFQ,
     *      DPMRA, DPMDC, IRET)
         IF (IRET .NE. 0) GO TO 999
 300     CONTINUE
C                                       Close SU table.
      CALL TABIO ('CLOS', 0, ISURNO, SUBUFF, SUBUFF, IRET)
      IF (IRET .NE. 0) GO TO 999
C                                       Exit
 999  RETURN
      END
      SUBROUTINE MK4CLS (LUNO, INDO, KBIND, NIOUT, IRET)
C-----------------------------------------------------------------------
C   Flushes I/O buffers, closes files and tables and updates the number
C   of visibilities in the catalog header.
C   Input:
C      LUNO    I     LUN for I/O
C      INDO    I     FTAB pointer for I/O
C      KBIND   I     buffer pointer
C      NIOUT   I     Number of vis in buffer.
C   Output:
C      IRET      I    Return error code, 0=>OK, else failed.
C   Input from common
C      KIGCN    I          No of random parm groups (uv vis records)
C      CNTVIS   I          Highest vis number + 1
C      FILSIZ   I          Output file size.
C      LREC     I          Length in values of a visibility record.
C   Input/output via common
C      BUFFER   R(UVBFSS)  Work buffer.
C      OFILE    C*48       Physical file name for output file.
C      CNOOUT   I          Output file sequence number.
C      DISKO    I          Output disk number.
C      CATBLK   I(256)     Catalog header.
C      MSGTXT   C*80       AIPS message string.
C-----------------------------------------------------------------------
      INTEGER   LUNO, INDO, KBIND, NIOUT, IRET
C
      INCLUDE 'MK4IN.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DHDR.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DFIL.INC'
C-----------------------------------------------------------------------
      IRET = 0
C                                       Finish write
C                                       Expand file?
      IF (CNTVIS.GT.FILSIZ) THEN
         CALL MK4XPN (LUNO, CNTVIS, IRET)
         IF (IRET.NE.0) THEN
C                                       Expansion failed - save what
C                                       you've got.
            MSGTXT = 'FILE EXPANSION FAILED - SOME DATA LOST'
            CALL MSGWRT (8)
            IRET = 0
C                                       Some data lost in buffer
            CNTVIS = CNTVIS - ABS (NIOUT) - 1
            GO TO 20
            END IF
         END IF
      NIOUT = - ABS (NIOUT)
      CALL UVDISK ('FLSH', LUNO, INDO, BUFFER(1), NIOUT, KBIND, IRET)
      IF (IRET.NE.0) THEN
         WRITE (MSGTXT,1000) IRET, 'FLUSH'
         GO TO 990
         END IF
C                                       Compress output file.
      CALL UCMPRS (CNTVIS, DISKO, CNOOUT, LUNO, CATBLK, IRET)
C                                       Close file
 20      CALL ZCLOSE (LUNO, INDO, IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET, 'CLOS'
            GO TO 990
            END IF
C                                      Put vis. count in CATBLK
         CATBLK(KIGCN) = CNTVIS
         CALL CATIO ('UPDT', DISKO, CNOOUT, CATBLK, 'REST', BUFFER,
     *      IRET)
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1001) IRET
            GO TO 990
            END IF
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('MK4CLS: ERROR ',I3,1X,A,'ING OUTPUT')
 1001 FORMAT ('MK4CLS: ERROR ',I3,' UPDATING OUTPUT CATALOG HEADER')
 1002 FORMAT ('MK4CLS: ERROR ',I3,' CLEARING OUTPUT FILE STATUS')
      END
      SUBROUTINE T2DHMS (TIMEIN, NDIG, TIME, RTIME)
C-----------------------------------------------------------------------
C   Convert from Time to Days Hours Minutes Seconds format
C   Input:
C      TIMEIN   R       Input:  Time
C      NDIG     I       Number digits in seconds display
C   Output:
C      TIME     I*(3)   Output Time in Days Hours Minutes
C      RTIME    R       SECONDS
C-----------------------------------------------------------------------
      REAL     TIMEIN, RTIME
      INTEGER  NDIG, TIME(3)
C
      REAL     T
      INTEGER  I, J
C-----------------------------------------------------------------------
      T = TIMEIN
      IF (TIMEIN.LT.0.0) T = -T
C
      TIME(1) = T
      T = (T - TIME(1)) * 24.0
      TIME(2) = T
      T = (T - TIME(2)) * 60.0
      TIME(3) = T
      T = (T - TIME(3)) * 60.0
      RTIME   = T
      J = 10 ** NDIG
      J = MAX (1, J)
      I = J*T + 0.5
C                                       Now Remove 60 seconds
      IF (I.GE.J*60) THEN
         RTIME = RTIME - 60.0
         TIME(3) = TIME(3) + 1
         END IF
C                                       Now Remove 60 minutes
      IF (TIME(3).GE.60) THEN
         TIME(3) = TIME(3) - 60
         TIME(2) = TIME(2) + 1
         END IF
C                                       Now Remove 24 hours
      IF (TIME(2).GE.24) THEN
         TIME(2) = TIME(2) - 24
         TIME(1) = TIME(1) + 1
         END IF
C                                       Sign
      IF (TIMEIN.LT.0.0) TIME(1) = -TIME(1)
C
 999  RETURN
      END
      SUBROUTINE CMSGWR( TEXT )
C-----------------------------------------------------------------------
C     Allow messages to written from C functions
C   Input:
C        TEXT   C*81   Message Text to be written
C   Input/output via common
C      MSGTXT   C*80       AIPS message string.
C-----------------------------------------------------------------------
      INCLUDE 'INCS:DMSG.INC'
      CHARACTER*81 TEXT
C-----------------------------------------------------------------------
C                                       Remove "0" bytes
      TEXT(81:81) = CHAR(0)
      TEXT(INDEX(TEXT,CHAR(0)):81) = '
     *                                                               '
C     
      WRITE(MSGTXT,'(A)') TEXT(1:80)
      CALL MSGWRT( 3 )
C     
      RETURN
      END
      SUBROUTINE MKSOLN (CURINN, IRET)
C-----------------------------------------------------------------------
C     Get the solutions for up to 2 stokes and write them to the BS
C     table. Mofiy errors for Probability of detection.
C   Input
C     CURINN   R          Current data time
C   Output
C     IRET     I          ERROR flag
C   Input/output via common
C     MSGTXT   C*80       AIPS message string.
C-----------------------------------------------------------------------
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'BSREC.INC'
      INCLUDE 'MK4TAB.INC'
      INCLUDE 'MKINP.INC'
      INCLUDE 'INCS:DMSG.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:PSTD.INC'
      INTEGER IRET, ZT(3)
      REAL PROBF, CURINN, SNRLIM, SNR, ZS
C-----------------------------------------------------------------------
C                                       Compute single-band and rate
C                                       ambiguities. All the same.
      SBDAMB = 1./(BWIFS(1)/MKAFRQ(1))
      RTAMB = 1./CURINN
      SNRLIM = APARM(3)
C
C                                       Loop over up to 2 stokes
      DO 100 STOKES = MKPOL1, MIN(MKPOL2,2)
C
C                                       Get the solutions
         CALL GETSOL (STOKES, BASELN, SOURCB, TUTS, INTTS, VAMP, SAMP,
     *      RMBD, MBDERR, MBDAMB, RRATE, RTERR, RSBD, SBDERR, RPHASE,
     *      PHSERR, PROBF, IRET ) 
C                                       Error check.
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1000) IRET
            GO TO 990
            END IF
C                                       No solution for this stokes
         IF (IRET.LT.0) GO TO 100
C                                       Catch rare case of no data
         IF (PROBF.EQ.1.) THEN
            WRITE (MSGTXT,1002)
            GO TO 990
            END IF
C                                       Modify errors with PROBF. This
C                                       is roughly what we do in
C                                       GLOBAL in the NCC package
         TOTSOL = TOTSOL + 1
         SNR= 1./(PHSERR*DG2RAD)
C         write(*,*) PHSERR,SNR,SNRLIM
         IF (PROBF .LT. 0.9 .AND. SNR .GE. SNRLIM) THEN
            MBDERR = MBDERR / SQRT(1-PROBF**0.2)
            SBDERR = SBDERR / SQRT(1-PROBF**0.2)
            RTERR = RTERR / SQRT(1-PROBF**0.2)
            PHSERR = PHSERR / SQRT(1-PROBF**0.2)
            ACCERR = 0.
         ELSE
            IF (MKPRNT.GT.2) THEN
               CALL T2DHMS( REAL(TUTS), 0, ZT, ZS )
               WRITE (MSGTXT,1010) BASELN, STOKES, SNR, ZT, ZS
               CALL MSGWRT (6)
               WRITE (MSGTXT,1011) RRATE*1.E3, RSBD*1.E6, RMBD*1.E6
               CALL MSGWRT (6)
               END IF
            MBDERR = FBLANK
            SBDERR = FBLANK
            RTERR = FBLANK
            PHSERR = FBLANK
            ACCERR = FBLANK
            BADSOL = BADSOL + 1
            ENDIF
         INTTS = INTTS/86400.
C                                       Store BS table row. We don't
C                                       know about subarrays. Frequency
C                                       IDs are not known to BS!
         SUBARR = 1
C                                       Phase is not useful here
         RPHASE = 0.
         CALL TABBS ('WRIT', BSBUFF, BSROW, BSCOLS, BSNUMV, BSIF,
     *      TUTS, INTTS, BASELN, SUBARR, -STOKES, SOURCB, VAMP, SAMP,
     $      RMBD, MBDERR, MBDAMB, RSBD, SBDERR, SBDAMB, RRATE, RTERR,
     $      RTAMB,RACCEL, ACCERR, RPHASE, PHSERR, IRET)
C                                       ERROR check
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1001) IRET
            GO TO 990
            END IF
C
C
 100  CONTINUE
C
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1000 FORMAT ('ERROR',I3,' Reading solutions in GETSOLN')
 1001 FORMAT ('ERROR',I3,' Writing BS table')
 1002 FORMAT ('PROBF = 1 found, rejected')
 1010 FORMAT ('Soln rejected from BASL',1X,2I2.2,' Stokes',I2,' SNR',
     *   F5.2,' at',3I3,1X,F3.0) 
 1011 FORMAT (' residuals rate,sdel,mdel',3F10.4)
      END
      SUBROUTINE MK4CAL (ISCAN, IA, IFQAID, IRET)
C-----------------------------------------------------------------------
C   Routine to create/fill CL table.
C   INPUT:     
C      ISCAN    I     Pointer to scan array
C      IA       I     Station number
C      IFQAID   I     Frequency ID
C   Output:
C      IRET     I     Return code, 0=>OK, else TABCAL or CALINI error.
C   Input from common
C      DBLANK   D          Magic value (= indeterminate).
C      FBLANK   R          REAL value indicating blanking.
C      IATOFF   R          IAT-UTC (seconds).
C      CURSOU   I     Current source number
C   Input/output via common
C      CURSOU   I          Current source number in SU table.
C      NIF      I          Number of IF's in output file.
C      NPOLN    I          Number of polarizations in output file.
C      CNOOUT   I          Output file sequence number.
C      DISKO    I          Output disk number.
C      CATBLK   I(256)     Catalog header.
C      CLBUFF   I(1024)    CL table buffer.
C      CLKOLS   I(50)      CL table column pointer array.
C      CLNUMV   I(50)      CL table element count in each column.
C      ICLRNO   I          Next scan number in CL table.
C-----------------------------------------------------------------------
      INTEGER   IRET, ISCAN, IA, IFQAID
C
      INTEGER   SUBA, NUMANT, NUMPOL, I, NCLS, IC, FREQID
      INCLUDE 'INCS:PUVD.INC'
      INCLUDE 'MK4IN.INC'
      INCLUDE 'PTABLE.INC'
      INCLUDE 'MKSCN.INC'
      INCLUDE 'MKINP.INC'
      INCLUDE 'MKSTA.INC'
      INCLUDE 'MK4TAB.INC'
      INCLUDE 'INCS:DCAT.INC'
      INCLUDE 'INCS:DUVH.INC'
      INCLUDE 'INCS:DDCH.INC'
      INCLUDE 'INCS:DMSG.INC'
C
      REAL CLINC, SCNDIF
      REAL DOPOFF(MXM4FQ), ATMOS, DATMOS, MBDELY(2), CLOCK(2),DCLOCK(2),
     *   DISP(2), DDISP(2), CREAL(2,MXM4FQ), CIMAG(2,MXM4FQ),
     *   CDELAY(2,MXM4FQ), CRATE(2,MXM4FQ),  WEIGHT(2,MXM4FQ), FAROT 
      INTEGER   REFA(2,MXM4FQ), MXM4X2
      PARAMETER (MXM4X2 = 2*MXM4FQ)
      DOUBLE PRECISION    GEODLY(3), TUTM
C
      DATA REFA /MXM4X2*0/
      DATA DOPOFF/MXM4FQ*0.0/
      DATA MBDELY, FAROT /2*0.0, 0.0/
      DATA ATMOS, DATMOS, DISP, DDISP /6*0.0/
      DATA CIMAG, CDELAY, CRATE /MXM4X2*0.0, MXM4X2*0.0, MXM4X2*0.0/
      DATA CREAL, WEIGHT  / MXM4X2*1.0, MXM4X2*1.0/
C-----------------------------------------------------------------------
      IRET = 0
C                                       Do we have more than 1 Subarr?
      SUBA = 1
C                                       Give maximum antenna number
      NUMANT = NANT
      NUMPOL = MIN (NPOLN, 2)
      FREQID = IFQAID
C
C                                       Determine times for CL tables
      SCNDIF = STPSCN(ISCAN)-STRSCN(ISCAN)
      NCLS = SCNDIF/CLINT +0.9
      CLINC = SCNDIF/NCLS
C      write(*,*)iscan,ia,ncls,clinc*60.*24.
C   
C                                       Loop through scan
      DO 400 IC = 0, NCLS
C         
         TUTM = STRSCN(ISCAN) + (CLINC*IC)
C                                       Clock + Rate at CL time
         CLOCK(1) = DTASYN(IA)/1.E6 + (DTACLK(IA)*((TUTM/86400.) -
     *      DTAEPO(I))) 
         DCLOCK(1) = DTACLK(IA)
         CLOCK(2) = CLOCK(1)
         DCLOCK(2) = DCLOCK(1)
C                                       Get the correlator model
         CALL CMPMDL (IA, TUTM, GEODLY, IRET)  
C         write(*,*)IA, TUTM, GEODLY, IRET
         IF (IRET.NE.0) THEN
            WRITE (MSGTXT,1000) IRET
            GO TO 400
            END IF
C
C                                       Write a row      
         CALL TABCAL ('WRIT', CLBUFF, ICLRNO, CLKOLS, CLNUMV,
     *      NUMPOL, NIF, TUTM, CLINC, CURSOU, IA, SUBA, FREQID,
     *      FAROT, GEODLY, DOPOFF, ATMOS, DATMOS, MBDELY,
     *      CLOCK, DCLOCK, DISP, DDISP, CREAL, CIMAG, CDELAY,
     *      CRATE, WEIGHT,  REFA, IRET)
         IF (IRET.GT.0) THEN
            WRITE (MSGTXT,1010) IRET
            GO TO 990
            END IF
C
 400        CONTINUE
C 
      GO TO 999
C                                       Error.
 990  CALL MSGWRT (8)
C
 999  RETURN
C-----------------------------------------------------------------------
 1010 FORMAT ('MK4CAL: ERROR ',I3,' WRITING TO CL TABLE')
 1000 FORMAT ('MK4CAL: ERROR ',I3,' in CMPMDL getting model')
      END
      SUBROUTINE MK4UVW (FIRST, T, IA1, IA2, IFQAID, U, V, W, IRET)
C-----------------------------------------------------------------------
C  MK4UVW developed from UVWCAL from UVFIX...
C
C  UVWCAL, on first call sets up quantities needed to compute u,v,w.
C  Calculates u,v,w for 1 datum on each call.
C   
C  Inputs:
C      II       L          Flag to indicate initialize
C      T        R          Time in days since 0 on the first day for which
C                          there is data.
C      IA1      I          First antenna number
C      IA2      I          Second antenna number
C      IFQAID   I          Pointer to frequency 
C
C  Inputs from COMMON
C      CURSOU   I          Pointer to source list
C      DTAFQT   D(fid#,if#) Set of AIPS IF frequencies for each
C      DECEPO   D(100)     DEC at  DEPOCH (deg)
C      DEPOCH   D(100)     Epoch for RA and DEC (e.g. 1590 or 2000)      
C      DRAEPO   D(100)     RA at  DEPOCH (deg)
C
C  Output via COMMON
C      DRAAPP   D(100)     apparent RA (deg)
C      DECAPP   D(100)     apparent DEC
C      DECEPO   D(100)     DEC at  DEPOCH (deg)
C      DRAEPO   D(100)     RA at  DEPOCH (deg)
C      DEPOCH   D(100)     Epoch for RA and DEC (2000)      
C
C  Output:
C      U        R          U in wavelengths
C      V        R          V in wavelengths
C      W        R          W in wavelengths
C
C  Output via COMMON
C      DRAAPP   D(100)     apparent RA (deg)
C      DECAPP   D(100)     apparent DEC
C      IRET     I          Return code  -1 => don't write
C                                0 => OK
C                               >0 => error, terminate.
C
C-----------------------------------------------------------------------
      INCLUDE 'MK4IN.INC'
      INTEGER IA1, IA2, IRET, I, IFQAID
      DOUBLE PRECISION  HAM, GASTM, GMSTM, TU, JD, JD0, C, HR2RD, TC,
     *   EPS, DELPSI, DELEPS, SPSI, SEPS, EQEQ, OBSPOS(3), RLST, RHOGEO,
     *   PHIGEO, XLONG, TRATE, RFRFRQ, DELDAT, RAAPR(MAXSOU),
     *   DECAPR(MAXSOU), SCALAR(MAXSOU), DTEMP1, DTEMP2, RRA,
     *   DDEC, RATE, JJD, RASTM, RLCOR
      DOUBLE PRECISION SRA, SSRA, SDEC, SSDEC, DDELTA, BEPOCH, R2000,
     *   D2000 
      REAL    U, V, W, T, TTCOR, POLAR(2),CROTP(MAXSOU), SROTP(MAXSOU),
     *   ROTP, UT, VT
      LOGICAL   TR, FL, FIRST
      DOUBLE PRECISION  GSTRA, XG1, YG1, ZG1, XG2, YG2, ZG2, TIME,
     *   BASEX, BASEY, BASEZ, VW,XM1, YM1, ZM1, XM2, YM2, ZM2,
     *   LENGTH, DEANT0, RAANT0, RAANT, DECANT, XMEQ 
C
      INCLUDE 'PTABLE.INC'
      INCLUDE 'MKSTA.INC'
      INCLUDE 'MK4TAB.INC'
      INCLUDE 'INCS:DANT.INC'
      INCLUDE 'INCS:PSTD.INC'
C
      SAVE HAM, JD, HR2RD, TTCOR, RATE, TRATE, OBSPOS
      SAVE  SCALAR, CROTP, SROTP, RAAPR, DECAPR, RASTM, RLCOR, POLAR
      DATA TR, FL /.TRUE.,.FALSE./
      DATA DELDAT /0.05D0/
      DATA JD0, C /2415020.0D0,2.9979250D8/
C-----------------------------------------------------------------------
C                                       Init files, precession
      IF (FIRST) THEN
         IRET = 8
C                                       Set some constants.
         HR2RD  = DG2RAD * 15.0D0
C   Here some AN table stuff deleted
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                        Julian Date
         JD = REFJD
C                                       Get equation of equinoxes.
         TC = (JD - 2433282.423D0) / 36524.21988D0
         EPS = -46.850D0 * TC - 0.0034D0 * TC * TC +
     *      0.0018D0 * TC * TC * TC
         EPS = (84404.84D0 + EPS) / 3600.0D0 / 180.0D0*3.141592658979D0
         CALL NUT4 (JD, DELPSI, DELEPS, SPSI, SEPS)
         EQEQ = DELPSI * COS (EPS)
C   Here some stuff deleted
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C            ARRAYC(1) = 0.0D0
C            ARRAYC(2) = 0.0D0
C            ARRAYC(3) = 1.0E-20
C   The above not needed either
C   Here some AN table stuff deleted
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
         RHOGEO = 0.0
         PHIGEO = 0.0
         XLONG = 0.0D0
         OBSPOS(1) = 0.0
         OBSPOS(2) = 0.0
         OBSPOS(3) = 0.0
C                                       position of the pole for JPREC
C					POLRXY are in arcsec  UNITS??
         POLAR(1) = DTWOB(1)
         POLAR(2) = DTWOB(2)
         RLST = 0.0D0
C                                        Compute earth rotation rate.
C                                        and GMST at UT midnight.
         TU = (JD - JD0) / 36525.0D0
         GMSTM = (8640184.542D0/3600.0D0) * TU
         GMSTM = MOD (GMSTM, 24.0D0)
         GMSTM = (6.0D0 + 38.0D0/60.0D0 + 45.836D0/3600D0) +
     *      GMSTM + (0.0929D0/3600.0D0) * TU * TU
         GASTM = GMSTM + (EQEQ / HR2RD)
         RATE = 1.00273790265D0 + 0.589D-10 * TU
         GSTIA0 = GMSTM * 15.0D0
         DEGPDY = RATE * 360.0D0
C                                       Save for AN table
         DTGAST = GSTIA0 
         DTSIDD = DEGPDY
         TTCOR = DTUT1 / 86400.0 
C   Here some stuff deleted
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                        Array center longitude.
C                                        HA at midnight.
         HAM = GASTM - XLONG
         TRATE = RATE * 24.0D0
C                                       recalculate the source position
C                                       at epoch
         JJD = JD + T + TTCOR
         DO 100 I = 1, NSOUR
C                                       recalculate the source position
C                                       from B1950 to J2000 for all
C                                       sources if needed
            IF (DEPOCH(I).LT.1975.0D0) THEN
               DEPOCH(I) = 2000.0D0
               BEPOCH = 1979.3D0
               RRA = DRAEPO(I) * DG2RAD
               DDEC = DECEPO(I) * DG2RAD
               CALL EPOCHS (RRA, DDEC, BEPOCH, R2000, D2000)
               DRAEPO(I) = R2000 / DG2RAD
               DECEPO(I) = D2000 / DG2RAD
               END IF
            RRA = DRAEPO(I) * DG2RAD
            DDEC = DECEPO(I) * DG2RAD
            CALL JPRECS (JJD, DEPOCH(I), DELDAT, 1, TR, FL, OBSPOS,
     $         POLAR, RRA,DDEC, RAAPR(I), DECAPR(I))
C                                       Save for SU table
C            DRAAPP(I) = RAAPR(I) / DG2RAD
C            DECAPP(I) = DECAPR(I) / DG2RAD
C-----------------------------------------------------------------
C     Abberation does not rotate image relatively UV in J2000 frame.
C     But the UV themselves are rotated as a result of change of
C     the direction. So if we use abberated UV to project baselines
C     (that is probably right decision), then the restored image
C     will be turned. The value of this rotation is proportional to
C     the abberation in the RA direction. In particular, if the
C     abberation works at the DECL direction (V-North) then
C     UV axes will not be turned at all.!!!!!
C-----------------------------------------------------------------
C                                       So lets estimate the UV axis
C                                       rotation as difference of the
C                                       RAs multiplyed by SIN(DDEC)
            ROTP = (RRA - RAAPR(I)) * SIN(DDEC)
C
            CROTP(I) = COS(ROTP)
            SROTP(I) = SIN(ROTP)
C                                       The rotation itself will be done
C                                       later
C
C                                       take a point 10 argsec north to
C                                       calculate the expansion due to
C                                       differential aberation (Lorentz
C                                       contraction)
            SRA = RRA
            DDELTA = (10.0/3600.0) * DG2RAD
            SDEC = DDEC + DDELTA
            CALL JPRECS (JJD, DEPOCH(I), DELDAT, 1, TR, FL, OBSPOS,
     *         POLAR, SRA, SDEC, SSRA, SSDEC)
            DTEMP1 = SSDEC - DECAPR(I)
            DTEMP2 = (SSRA - RAAPR(I)) * COS (DDEC)
            DTEMP1 = SQRT (DTEMP1*DTEMP1 + DTEMP2*DTEMP2)
            SCALAR(I) = DTEMP1 / DDELTA
 100        CONTINUE
C
         RASTM = GASTM * HR2RD
         RLCOR = 24.0D0 * HR2RD * RATE
C
C-----------------------------------------------------------------------
         END IF
C                                       Now the part for every
C                                       visibility 
      IRET = 0
C
C                                       Precess position.
      JJD = JD + (T + TTCOR)
      RLST = RASTM + T * RLCOR
C                                       corrected time in days
      TIME = T + TTCOR
C                                       Reference frequency
C                                       Use first IF
      RFRFRQ = DTAFQT(IFQAID,1)
C
C                                        Compute u, v, w
      GSTRA = (HAM + TRATE * TIME) * 15 * DG2RAD
C      IORB1 = IORBIT(IA1)
C      IORB2 = IORBIT(IA2)
C                                       The first antenna
C      IF (IORB1 .GT. 0) THEN
C                                       find X,Y,Z of the orbiting
C                                       antenna, using fitting polinoms
C                                       found early
C         CALL XYZOR (NINTER, TIMEOR, TBEG, TEND, NFIT, KFIT,
C     *      AAX, AAY, AAZ, XM1, YM1, ZM1, IRET)
C      ELSE
C                                       Changed the sign for YG1 fpr RH as
C                                        The formulae for U,V,W are
C                                       written in RH. But rotating
C                                       antenna vector by GSTRA I
C                                       carried out change the Y sign.
C                                       So the antennas should be given
C                                       at LH!!!!!!
C                                       AIPS now forces RH.
C                                       So sign of Y is changed
      XG1 = DTALOC(1,IA1)
      YG1 = -DTALOC(2,IA1)
      ZG1 = DTALOC(3,IA1)
      XM1 = XG1*COS(GSTRA) + YG1*SIN(GSTRA)
      YM1 = XG1*SIN(GSTRA) - YG1*COS(GSTRA)
      ZM1 = ZG1
C                                       position of the ground based
C                                       antenna found for the
C                                       observation time sky
C                                       coordinate system
C
      LENGTH = SQRT (XM1*XM1 + YM1*YM1 + ZM1*ZM1)
      RAANT = ATAN2 (YM1, XM1)
      DECANT = ASIN (ZM1 / LENGTH)
C                                       Let's recalculate the vector
C                                       Center of Earth - antenna to
C                                       the standard epoch frame.
C                                       Apply only rotation to the
C                                       antenna vector.
C                                       We use the private version of
C                                       JPRECS to provide the rotation
C                                       only.
      CALL JPRECS (JJD, DEPOCH(CURSOU), DELDAT, -1, FL, TR, OBSPOS,
     $   POLAR, RAANT0, DEANT0, RAANT, DECANT)
      XMEQ = LENGTH * COS(DEANT0)
      XM1 = XMEQ * COS(RAANT0)
      YM1 = XMEQ * SIN(RAANT0)
      ZM1 = LENGTH * SIN(DEANT0)
C         END IF
C                                       The second antenna
C      IF (IORB2 .GT. 0) THEN
C         CALL XYZOR (NINTER, TIMEOR, TBEG, TEND, NFIT, KFIT,
C     *      AAX, AAY, AAZ, XM2, YM2, ZM2, IRET)
C      ELSE
C                                       Same for Y sign here
      XG2 = DTALOC(1,IA2)
      YG2 = -DTALOC(2,IA2)
      ZG2 = DTALOC(3,IA2)
      XM2 = XG2*COS(GSTRA) + YG2*SIN(GSTRA)
      YM2 = XG2*SIN(GSTRA) - YG2*COS(GSTRA)
      ZM2 = ZG2
C                                       position of the ground based
C                                       antenna found for the
C                                       observation time sky
C                                       coordinate system
C
      LENGTH = SQRT (XM2*XM2 + YM2*YM2 + ZM2*ZM2)
      RAANT = ATAN2 (YM2, XM2)
      DECANT = ASIN (ZM2 / LENGTH)
C                                       Let's recalculate the vector
C                                       Center of Earth - antenna to the
C                                       standard epoch frame
      CALL JPRECS (JJD, DEPOCH(CURSOU), DELDAT, -1, FL, TR, OBSPOS,
     $   POLAR, RAANT0, DEANT0, RAANT, DECANT)
      XMEQ = LENGTH * COS(DEANT0)
      XM2 = XMEQ * COS(RAANT0)
      YM2 = XMEQ * SIN(RAANT0)
      ZM2 = LENGTH * SIN(DEANT0)
C         END IF
C                                       calculate baseline
      BASEX = XM2 - XM1
      BASEY = YM2 - YM1
      BASEZ = ZM2 - ZM1
C                                       U, V, W in meters
      VW = BASEX * COS(RAAPR(CURSOU)) + BASEY * SIN(RAAPR(CURSOU))
C                                       The following formulae are valid
C                                       for RH coordinate system:
C                                       RA increase from X to Y
C                                       U,V,W in meters
      UT = -BASEX * SIN(RAAPR(CURSOU)) + BASEY * COS(RAAPR(CURSOU))
      VT = -VW * SIN(DECAPR(CURSOU)) + BASEZ * COS(DECAPR(CURSOU))
      W = VW * COS(DECAPR(CURSOU)) + BASEZ * SIN(DECAPR(CURSOU))
C                                       rotate because of abberation
      U = UT * CROTP(CURSOU) + VT * SROTP(CURSOU)
      V = VT * CROTP(CURSOU) - UT * SROTP(CURSOU)
C                                       U,V,W in wavelengths
      U = -U * RFRFRQ / C
      V = -V * RFRFRQ / C
      W = -W * RFRFRQ / C
C                                       include differential aberation
C                                       (Lorentz contraction)
      U = U * SCALAR(CURSOU)
      V = V * SCALAR(CURSOU)
C
C-----------------------------------------------------------------------
C
      RETURN
      END
      SUBROUTINE JPRECS (JD, EQUIN, DELDAT, DIR, NROT, ROT, OBSPOS,
     *   POLAR, RAMEAN, DECMEA, RAAPP, DECAPP)
C-----------------------------------------------------------------------
C! Precess between apparent and J2000 epoch positions. (from UVFIX)
C# Math Coordinates
C-----------------------------------------------------------------------
C   Routine to precess positions using the Julian IAU 1984 conventions,
C   (i.e. J2000 positions).  Optional corrections can be made for
C   relativistic bending of the light by the sun, diurnal aberation and
C   polar motion.  Proper motion and parallax are assumed negligible.
C   This is a private version of the AIPS routine. The parameters NROT, ROT
C   switch on/off all other effects (not rotation) and rotation.
C   Several bugs which prevented exact returning back to the mean
C   coordinates (DIR=1 => DIR=-1) are fixed by L. Kogan August 8, 2001
C   Inputs:
C     JD       D  Julian date of observation (e.g. 2446754.123445).
C     EQUIN    D  Epoch of mean equinox (e.g. 2000.0)
C     DELDAT   D  Interpolation interval; compute precession etc.
C                 parameters at this interval and do a linear
C                 interpolation (days).
C     DIR      I  1 => convert from mean to apparent;
C                -1 => convert from apparent to mean.
C     NROT     L  If true correct apparent position for all other
C                 effects (not rotation): abberation, the general
C                 relativistic bending of light by the sun.
C     ROT      L  If true correct for rotation, including precesion and
C                 nutation
C     OBSPOS(3)D  Earth centered location of the observations.
C                 If non zero then diurnal aberation corrections are
C                 made for this location.
C                 1 = Latitude (radians)
C                 2 = East longitude
C                 3 = radius from earth center (meter).
C     POLAR(2) R  X and Y position of the pole (arcsec.)
C                 If non zero then the apparent position is corrected
C                 for the position of the pole.
C                 Note: this correction is not desirable if the antenna
C                 positions are corrected for polar motion.
C    Input/Output:
C     RAMEAN   D  Right ascension at the mean epoch (radians).
C     DECMEA   D  Declination at mean epoch.
C     RAAPP    D  Apparent Right ascension at JD and OBSPOS.
C     DECAPP   D  Apparent declination.
C-----------------------------------------------------------------------
      DOUBLE PRECISION JD, EQUIN, DELDAT, OBSPOS(3), RAMEAN, DECMEA,
     *   RAAPP, DECAPP
      REAL      POLAR(2)
      INTEGER   DIR
      LOGICAL NROT, ROT
      INTEGER   ITEMP, I, J, DIROLD
      LOGICAL   DIURN
      DOUBLE PRECISION JDINT(2), PRNMAT(3,3,2), POSO(3,2), VELO(3,2),
     *   RLST, POS(3), WT1, WT2, TU, GMST, TIME, ROTI(3,3), POSOI(3),
     *   VELOI(3), CONST, V(3), BETA, PDOTV, CONST2, OUT(3), RHOGEO,
     *   GMST0, OBSOLD(3)
C
      DOUBLE PRECISION LENGTH, POSSQR, OUTSQR, VSQR, SD, CD, DRA,
     *   DDEC, AYX, AZX, BYX, BZX
      INCLUDE 'INCS:PSTD.INC'
      SAVE JDINT, PRNMAT, POSO, VELO, OBSOLD, DIROLD
      DATA JDINT, OBSOLD /5*0.0D0/
      DATA DIROLD /100/
C-----------------------------------------------------------------------
C                                       Stmt. fn. to compute GMST at
C                                       IAT=0 in radians.
      GMST0 (TU) = MOD (((((((-6.2D-6 * TU) + 0.093104D0) *
     *   TU) + 8640184.812866D0) * TU + 24110.54841D0) * TWOPI /
     *   86400.0D0), TWOPI)
C-----------------------------------------------------------------------
C                                       Convert to rectangular
C                                       coordinates.
      IF (DIR.GT.0) THEN
         POS(1) = COS (RAMEAN) * COS (DECMEA)
         POS(2) = SIN (RAMEAN) * COS (DECMEA)
         POS(3) = SIN (DECMEA)
      ELSE
         POS(1) = COS (RAAPP) * COS (DECAPP)
         POS(2) = SIN (RAAPP) * COS (DECAPP)
         POS(3) = SIN (DECAPP)
         END IF
C                                       New set of interpolation values?
      IF (((JD.LT.JDINT(1)) .OR. (JD.GT.JDINT(2))) .OR.
     *      (DIR.NE.DIROLD) .OR.
     *      ((ABS (OBSPOS(1)-OBSOLD(1)) + ABS (OBSPOS(2)-OBSOLD(2)) +
     *      ABS (OBSPOS(3)-OBSOLD(3))).GT.1.0D-5)) THEN
         JDINT(1) = JD
         JDINT(2) = JD + DELDAT
         OBSOLD(1) = OBSPOS(1)
         OBSOLD(2) = OBSPOS(2)
         OBSOLD(3) = OBSPOS(3)
         DIROLD = DIR
C                                       Beginning of interpolation
C                                       Precession and nutation
         IF (ROT)
     *      CALL JPRENU (DIR, JDINT(1), EQUIN, .TRUE., PRNMAT(1,1,1))
         IF (NROT) THEN
C                                       Aberation and light bending
            DIURN = (ABS (OBSPOS(3)) .GT. 1.0D-5)
            RHOGEO = 0.0
            RLST = 0.0
C                                       Following for diurnal aberation.
            IF (DIURN) THEN
               RHOGEO = OBSPOS(3) / 6378140.0D0
               ITEMP = JDINT(1)
               TIME = (JDINT(1) - ITEMP - 0.5D0) * TWOPI * 1.002737778D0
               TU = (JDINT(1) - 2451545.0D0) / 36525.0D0
               GMST = GMST0 (TU) + TIME
               RLST = OBSPOS(2) + GMST
               END IF
            CALL JABER (JDINT(1), EQUIN, DIURN, RHOGEO, OBSPOS(1),
     *         RLST,POSO(1,1), VELO(1,1))
            END IF
C                                       End on interpolation,
C                                       don't interpolate less than 1
C                                       sec.
         IF (DELDAT.GT.1.15741D-5) THEN
C                                       Precession and nutation
            IF (ROT)
     *         CALL JPRENU (DIR, JDINT(2), EQUIN, .TRUE., PRNMAT(1,1,2))
            IF (NROT) THEN
C                                       Aberation and light bending
               IF (DIURN) THEN
                  ITEMP = JDINT(2)
                  TIME = (JDINT(2) - ITEMP - 0.5D0) * TWOPI *
     *               1.002737778D0
                  TU = (JDINT(2) - 2451545.0D0) / 36525.0D0
                  GMST = GMST0 (TU) + TIME
                  RLST = OBSPOS(2) + GMST
                  END IF
               CALL JABER (JDINT(2), EQUIN, DIURN, RHOGEO, OBSPOS(1),
     *               RLST,POSO(1,2), VELO(1,2))
               END IF
            END IF
         END IF
C                                       Interpolate vectors and matrix.
      WT1 = 1.0D0
      IF (DELDAT.GT.1.15741D-5)
     *   WT1 = (JDINT(2) - JD) / (JDINT(2) - JDINT(1))
      WT2 = 1.0D0 - WT1
      DO 60 I = 1,3
         IF (NROT) THEN
            POSOI(I) = WT1 * POSO(I,1) + WT2 * POSO(I,2)
            VELOI(I) = WT1 * VELO(I,1) + WT2 * VELO(I,2)
            END IF
         IF (ROT) THEN
            DO 50 J = 1,3
               ROTI(J,I) = WT1 * PRNMAT(J,I,1) + WT2 * PRNMAT(J,I,2)
   50          CONTINUE
            END IF
 60      CONTINUE
C                                       Reduce position.
      IF (DIR.GT.0) THEN
C                                       Mean to apparent.
C                                       Light deflection
C                                       using the routine GRD
         IF (NROT) THEN
            SD = SIN(DECMEA)
            CD = COS(DECMEA)
            CALL GRD (JD, RAMEAN, DECMEA, SD, CD, DRA, DDEC)
            RAAPP = RAMEAN + DRA
            DECAPP= DECMEA + DDEC
            POS(1) = COS (RAAPP) * COS (DECAPP)
            POS(2) = SIN (RAAPP) * COS (DECAPP)
            POS(3) = SIN (DECAPP)
C                                       Aberation
            V(1) = VELOI(1) * 0.0057755D0
            V(2) = VELOI(2) * 0.0057755D0
            V(3) = VELOI(3) * 0.0057755D0
            BETA = SQRT (1.0D0 - (V(1)*V(1) + V(2)*V(2) + V(3)*V(3)))
            PDOTV = POS(1)* V(1) + POS(2)*V(2) + POS(3)*V(3)
C
            CONST = (1.0D0 + (PDOTV / (1.0D0 + BETA))) / (1.0D0 + PDOTV)
            CONST2 = BETA / (1.0D0 + PDOTV)
            POS(1) = POS(1)*CONST2 + CONST*V(1)
            POS(2) = POS(2)*CONST2 + CONST*V(2)
            POS(3) = POS(3)*CONST2 + CONST*V(3)
            OUT(1) = POS(1)
            OUT(2) = POS(2)
            OUT(3) = POS(3)
            END IF
         IF (ROT) THEN
C                                       Precession and nutation
            OUT(1) = POS(1)*ROTI(1,1) + POS(2)*ROTI(2,1) + POS(3)
     *         *ROTI(3,1)
            OUT(2) = POS(1)*ROTI(1,2) + POS(2)*ROTI(2,2) + POS(3)
     *         *ROTI(3,2)
            OUT(3) = POS(1)*ROTI(1,3) + POS(2)*ROTI(2,3) + POS(3)
     *         *ROTI(3,3)
C
            LENGTH = SQRT(OUT(1)*OUT(1) + OUT(2)*OUT(2) + OUT(3)*OUT(3))
            OUT(1) = OUT(1)/LENGTH
            OUT(2) = OUT(2)/LENGTH
            OUT(3) = OUT(3)/LENGTH
            END IF
      ELSE
C                                       Apparent to mean
         OUT(1) = POS(1)
         OUT(2) = POS(2)
         OUT(3) = POS(3)
C
         IF (ROT) THEN
C                                       Precession and nutation
            OUT(1) = POS(1)*ROTI(1,1) + POS(2)*ROTI(2,1) + POS(3)*
     *         ROTI(3,1)
            OUT(2) = POS(1)*ROTI(1,2) + POS(2)*ROTI(2,2) + POS(3)*
     *         ROTI(3,2)
            OUT(3) = POS(1)*ROTI(1,3) + POS(2)*ROTI(2,3) + POS(3)*
     *         ROTI(3,3)
            END IF
         IF (NROT) THEN
C                                       Aberation
            V(1) = VELOI(1) * 0.0057755D0
            V(2) = VELOI(2) * 0.0057755D0
            V(3) = VELOI(3) * 0.0057755D0
C                                       let's calculate LENGTH.
C                                       The vector out*length is equal
C                                       to vector at DIR=1 before
C                                       precession+nutation
            BETA = SQRT (1.0D0 - (V(1)*V(1) + V(2)*V(2) + V(3)*V(3)))
            PDOTV = POS(1)* V(1) + POS(2)*V(2) + POS(3)*V(3)
C
            CONST = (1.0D0 + (PDOTV / (1.0D0 + BETA))) / (1.0D0 + PDOTV)
            CONST2 = BETA / (1.0D0 + PDOTV)
            POSSQR = POS(1)*POS(1) + POS(2)*POS(2) + POS(3)*POS(3)
            OUTSQR = OUT(1)*OUT(1) + OUT(2)*OUT(2) + OUT(3)*OUT(3)
            VSQR = V(1)*V(1) + V(2)*V(2) +V(3)*V(3)
C
            LENGTH = SQRT((POSSQR*CONST2*CONST2 + VSQR*CONST*CONST
     *      + 2*PDOTV*CONST2*CONST) / OUTSQR)
C
            OUT(1) = OUT(1)*LENGTH
            OUT(2) = OUT(2)*LENGTH
            OUT(3) = OUT(3)*LENGTH
C                                       Solve the system of equations
C                                       to find nonaberrated coordinates
C                                       from aberrated ones
            AYX = (OUT(2) - V(2)/(1+BETA)) / (OUT(1) - V(1)/(1+BETA))
            AZX = (OUT(3) - V(3)/(1+BETA)) / (OUT(1) - V(1)/(1+BETA))
            BYX = (AYX*V(1) - V(2)) / (1+BETA)
            BZX = (AZX*V(1) - V(3)) / (1+BETA)
C                                       Solution of the equation
C                                       for OUT(1)
            OUT(1) = ((1 + BYX*V(2) + BZX*V(3))*(OUT(1) - V(1)/(1+BETA))
     *         - (BETA/(1+BETA))*V(1)) / (BETA - (OUT(1) - V(1)/(1+BETA)
     *         )* (V(1) + AYX*V(2) + AZX*V(3)))
C                                       find OUT(2) and OUT(3)
C                                       knowing OUT(1)
            OUT(2) = BYX + AYX*OUT(1)
            OUT(3) = BZX + AZX*OUT(1)
C                                       Light deflection?
C                                       using the routine GRD
            RAAPP = ATAN2 (OUT(2), OUT(1))
            IF (RAAPP.LT.0.0D0) RAAPP = RAAPP + TWOPI
            DECAPP = ASIN (OUT(3))
            SD = SIN(DECAPP)
            CD = COS(DECAPP)
            CALL GRD (JD, RAAPP, DECAPP, SD, CD, DRA, DDEC)
            RAMEAN = RAAPP - DRA
            DECMEA = DECAPP -  DDEC
            OUT(1) = COS (RAMEAN) * COS (DECMEA)
            OUT(2) = SIN (RAMEAN) * COS (DECMEA)
            OUT(3) = SIN (DECMEA)
            END IF
         END IF
C                                       Polar motion
         IF (ROT) THEN
            IF ((ABS (POLAR(1)) + ABS (POLAR(2))).GT.1.0E-20)
     *         CALL JPOLAR (DIR, POLAR(1), POLAR(2), OUT)
            END IF
C                                       Convert to spherical coord.
      IF (DIR.GT.0) THEN
C                                       Mean to apparent
         RAAPP = ATAN2 (OUT(2), OUT(1))
         IF (RAAPP.LT.0.0D0) RAAPP = RAAPP + TWOPI
         DECAPP = ASIN (OUT(3))
      ELSE
C                                       Apparent to mean
         RAMEAN = ATAN2 (OUT(2), OUT(1))
         IF (RAMEAN.LT.0.0D0) RAMEAN = RAMEAN + TWOPI
         DECMEA = ASIN (OUT(3))
         END IF
C
 999  RETURN
      END
      SUBROUTINE EPOCHS (R1950, D1950, BEPOCH, R2000, D2000)
C-----------------------------------------------------------------------
C   Routine to convert B1950.0 coordinates to J2000.0 (from UVFIX)
C   Input:
C      R1950,D1950 D     B1950.0 RA, Dec (rad)
C      BEPOCH      D     Besselian epoch (e.g. 1979.3D0)
C   Output:
C      R2000,D2000 D     J2000.0 RA, Dec (rad)
C-----------------------------------------------------------------------
      DOUBLE PRECISION R1950, D1950, BEPOCH, R2000, D2000
      DOUBLE PRECISION D2PI
      PARAMETER (D2PI=6.283185307179586476925287D0)
      DOUBLE PRECISION W, EPB2D
      INTEGER I,J
C                                       Position and position+velocity
C                                       vectors
      DOUBLE PRECISION R0(3),A1(3),V1(3),V2(6)
C                                       Radians per year to arcsec per
C                                       century
      DOUBLE PRECISION PMF
      PARAMETER (PMF=100D0*60D0*60D0*360D0/D2PI)
C
      DOUBLE PRECISION A(3), AD(3), EM(6,3), R, COSB
      DATA A, AD/ -1.62557D-6,  -0.31919D-6, -0.13843D-6,
     *           +1.245D-3,    -1.580D-3,   -0.659D-3/
C
      DATA (EM(I,1),I=1,6) / +0.9999256782D0,
     *                       +0.0111820610D0,
     *                       +0.0048579479D0,
     *                       -0.000551D0,
     *                       +0.238514D0,
     *                       -0.435623D0 /
C
      DATA (EM(I,2),I=1,6) / -0.0111820611D0,
     *                       +0.9999374784D0,
     *                       -0.0000271474D0,
     *                       -0.238565D0,
     *                       -0.002667D0,
     *                       +0.012254D0 /
C
      DATA (EM(I,3),I=1,6) / -0.0048579477D0,
     *                       -0.0000271765D0,
     *                       +0.9999881997D0,
     *                       +0.435739D0,
     *                       -0.008541D0,
     *                       +0.002117D0 /
C-----------------------------------------------------------------------
C                                       Spherical to Cartesian
      COSB = COS(D1950)
      R0(1) = COS(R1950) * COSB
      R0(2) = SIN(R1950) * COSB
      R0(3)  =SIN(D1950)
C                                       Adjust vector A to give zero
C                                       proper motion in FK5
      W=(BEPOCH - 1950D0) / PMF
      DO 10, I = 1, 3
         A1(I) = A(I) + W * AD(I)
   10    CONTINUE

C                                       Remove e-terms
      W = R0(1) * A1(1) + R0(2) * A1(2) + R0(3) * A1(3)
      DO 20 I = 1, 3
         V1(I) = R0(I) - A1(I) + W * R0(I)
   20    CONTINUE
C                                       Convert position vector to
C                                       Fricke system
      DO 40 I = 1, 6
         W = 0.0D0
         DO 30 J = 1,3
            W = W + EM(I,J) * V1(J)
   30       CONTINUE
         V2(I)=W
   40    CONTINUE
C                                       Allow for fictitious proper
C                                       motion in FK4
      EPB2D = 15019.81352D0 + (BEPOCH - 1900D0) * 365.242198781D0
C
      W = ((EPB2D - 51544.5D0) / 365.25D0) / PMF
      DO 50 I=1,3
         V2(I) =V2(I) + W * V2(I + 3)
   50    CONTINUE
C                                       Revert to spherical coordinates
      R = SQRT(V2(1) * V2(1) + V2(2) * V2(2))
      IF (R .EQ. 0D0) THEN
         W = 0D0
      ELSE
         W = ATAN2(V2(2),V2(1))
         END IF
      IF (V2(3) .EQ. 0D0) THEN
         D2000 = 0D0
      ELSE
         D2000 = ATAN2(V2(3), R)
         END IF
      R2000 = MOD(W, D2PI)
      IF (R2000 .LT. 0D0) R2000 = R2000 + D2PI
C
 999  RETURN
      END
C*DMS  From CLAP library
      FUNCTION  DMS( D, ND )
C 
C     Encodes angles to DD MM SS.SSSS
C     ND number of digits, D in degrees
C 
      CHARACTER*15      DMS,  BUFFER
      DOUBLE PRECISION  D,    Z, EPS
C 
      INTEGER I, ND
      REAL  A,  ROUND(0:5)
      CHARACTER*10  FD(1:5) 
C 
C 
C 
      DATA  ROUND  /  .5E0, .5E-1, .5E-2, .5E-3, .5E-4, .5E-5  /
      DATA  FD  / '(F2.1)', '(F3.2)', '(F4.3)', '(F5.4)', '(F6.5)' /
      DATA  EPS  / 1.D-6 /
C 
C 
C 
      Z  =  DMOD(  DMOD( D, 360.D0 )   + 540.D0, 360.D0  )  - 180.D0 
C 
      IF  ( Z .GE. 0.D0 )  THEN 
        WRITE ( BUFFER(1:1), '(1H+)' )
      ELSE
        WRITE ( BUFFER(1:1), '(1H-)' )
        Z = -Z
      ENDIF 
C 
      I  =  INT( Z + EPS )
      WRITE  ( BUFFER(2:3), '(I2.2)' )  I 
C 
      Z  =  ( Z - DBLE( I ) )  *60.D0 
      I  =  INT( Z + EPS )
      WRITE  ( BUFFER(4:6), '(I3.2)' )  I 
C 
      A  =  SNGL( Z - DBLE( I ) )  *60.  +  ROUND(ND) 
      I  =  INT( A )
      WRITE  ( BUFFER(7:9), '(I3.2)' )  I 
C 
      IF  ( ND .GT. 0 )  THEN 
        A  =  A - FLOAT( I ) - ROUND(ND)  +ROUND(ND)*0.1
        WRITE  ( BUFFER(10:), FD(ND) )  A 
        ENDIF 
C 
      DMS = BUFFER
C 
C 
C 
      RETURN
      END
C*HMS  From CLAP library
      FUNCTION  HMS( D, ND )
C 
C     Encdes angles to HH MM SS.SSSS
C     ND number of digits, D in hours
C 
      CHARACTER*15      HMS,  BUFFER
      DOUBLE PRECISION  D,    Z, EPS
C 
      INTEGER I, ND
      REAL  A,  ROUND(0:6)
      CHARACTER*10  FD(1:6) 
C 
C 
C 
      DATA  ROUND  /  .5E0, .5E-1, .5E-2, .5E-3, .5E-4, .5E-5, .5E-6  / 
      DATA  FD /'(F2.1)','(F3.2)','(F4.3)','(F5.4)','(F6.5)','(F7.6)'/
      DATA  EPS  / 1.D-6 /
C 
C 
C 
      Z  =  DMOD(  DMOD( D /360.0D0 *24.D0, 24.D0 )  + 24.D0, 24.D0  ) 
C 
      I  =  INT( Z + EPS )
      WRITE  ( BUFFER(1:2), '(I2.2)' )  I 
C 
      Z  =  ( Z - DBLE( I ) )  *60.D0 
      I  =  INT( Z + EPS )
      WRITE  ( BUFFER(3:5), '(I3.2)' )  I 
C 
      A  =  SNGL( Z - DBLE( I ) )  *60.  +  ROUND(ND) 
      I  =  INT( A )
      WRITE  ( BUFFER(6:8), '(I3.2)' )  I 
C 
      IF  ( ND .GT. 0 )  THEN 
        A  =  A - FLOAT( I ) - ROUND(ND)  +ROUND(ND)*0.1
        WRITE  ( BUFFER(9:), FD(ND) )  A
        ENDIF 
C 
      HMS = BUFFER
C 
C 
C 
      RETURN
      END 
