      program mymain
      character*256 infile
      character*8 refday,antnam(50)     !refday,50 antenna names
      real iatoff                       !32 sec
      double precision dtaloc(3,50)     ! xyz for 50 antennas
      double precision dtasyn(50),dtaepo(50),dtaclk(50),dtaep1(50)
      double precision dtafqt(50,16)    ! 16 frequencies in Hz ,50 modes
      integer itnafq (50)               !  no of IFs in each of 50 setups 
      real bandw(50)                    ! bandwidth Hz (50)
      integer mkafrq (50)               ! number of chans in spectrum (50)
      integer ifside(50,16)             ! sideband (1=USBi,-1=LSB,0=DSB) 50 setups,16chans
cc      integer ifpol(50,16)              ! poln of IF (1=R,2=L) 16chan 50 setups
      real axoff(50)
      double precision dtwob(2),dtut1,dtgast,dtsidd  !xy ut1,sid time and rate
      integer mntsta(50)
      character*16 srclst(30)           !source names wanted
      character*16 sulist(100)          !source names got
      integer desel                     !=1 for deselect or 0 for select (was logical)
      double precision draepo(100),decepo(100),depoch(100) !degrees radecatepoch (2000?) ,epoch
      double precision draapp(100),decapp(100)                !at refday, presently set to zero
      integer mxtvis,ia1,ia2,iaref,ifqaid,cursou       !for crspec
      integer istoke,dsb,crslgt
      integer numsrc,nant,nsour,ntafqt,iexp,ierr,iret
      integer i,j,ia1l,ia2l
      real crossp(3,2044), curint
      double precision tutc
      integer nifqaid(16),ncursou(10),nistoke(4)
      real test(1028)     !just a little integration array
      do i=1,1028
       test(i)=0
      enddo
c .. first set up selection criteria
c..select/deselect  source
c     desel=1     !everything except these two sources
      desel=0     !  only these three sources
c     numsrc=3    !  if = 0 will select all, otherwise number in list
c     srclst(1)="3C273B"
c     srclst(2)="3C279"
c     srclst(3)="CTA102"
      numsrc=0
c     call VXTIMERANG(0,9,59,0,0,10,1,0)  ! (all integers)scan start at 10:00 accepted
      call VXTIMERANG(0,0,00,0,10,0,1,0)  ! (all integers)all accept
c     call VXTIMERANG(0,5,37,0,0,5,39,0)  ! (all integers)all accept
c     infile="/correlator/dataa/DAG/1630"               !(test  path now without 0 term) 
c     iexp=1630     ! 4-stellig
      infile="/correlator/dataa/DAG/1578"               !(test  path now without 0 term) 
      iexp=1578     ! 4-stellig
c     infile="/data/1104"               !(test  path now without 0 term) 
c     iexp=1104     ! 4-stellig: test poln mm
      call INIVEX(INFILE,IEXP,IRET)
cc
      call VXREFD(REFDAY,DTWOB,DTUT1,IATOFF,DTGAST,DTSIDD,IERR)
cc
      print *,"refday,iatoff,ierr=",refday,iatoff,ierr
      print *,"ut1,wobxy,gast,sidrate=",dtut1,dtwob(1),dtwob(2),
     >         dtgast,dtsidd
cc
      call VXANT(NANT,ANTNAM,DTALOC,AXOFF,MNTSTA,
     > DTASYN,DTAEPO,DTACLK,DTAEP1,IERR)
      print *,"ants="
      do  i=1,nant
        print 1000,i,antnam(i),dtaloc(1,i),dtaloc(2,i),dtaloc(3,i),
     >     axoff(i),mntsta(i),dtasyn(i),dtaepo(i)/(356.243*86400.0),
     >     dtaclk(i), dtaep1(i)/(356.243*86400.0)
 1000   format(I4,1X,A8,1x,3F14.4,F7.4,i4,F9.4,F11.4,D12.4,F11.4) 
      enddo
cc
      print *,"call vxfreqs"
      CALL VXFREQ (NTAFQT,ITNAFQ,DTAFQT,BANDW,MKAFRQ,IFSIDE,IERR)
      print *,"number of setups",ntafqt
      print *," set  chan     freq        bandw  sideb  "
c     do j=1,ntafqt
      do j=1,2
c       do i=1,itnafq(j)
        do i=1,16
          print 1001,j,i,dtafqt(j,i)/1.0d6,bandw(j)/1.0D6,
     >      ifside(j,i)
 1001     format(2i4,F14.2,1x,F10.3,I5,I3)
        enddo
      enddo
      print *,"call vxsou"
      print *,"selecting:",srclst(1),":",srclst(2),":",srclst(3),":"
      call VXSOU(NUMSRC,DESEL,SRCLST,NSOUR,SULIST,DRAEPO,DECEPO,
     >  DEPOCH,DRAAPP,DECAPP,IERR)
      print *,"number of sources=",nsour," err=",ierr
      do i=1,nsour
        print 1002,i,sulist(i),draepo(i)/15.0,decepo(i),depoch(i),
     >   draapp(i)/15.0,decapp(i)
 1002    format(i3,1x,a16,f10.5,f10.5,f7.1,f10.5,f10.5)
      enddo
c     print *,"debug we are going to stop now!"
c     stop    !debugging
      mxtvis=2044
c.. now try to read data in a loop until error or data end..
 666  call CRSPEC(MXTVIS,TUTC,IA1,IA2,IAREF,IFQAID,CURSOU,
     >  CURINT,ISTOKE,DSB,CROSSP,CRSLGT,IRET)
c     if(iret .eq. 0) print *,"crspec returns OK"
      if(iret .gt. 0)then
         print *,"crspec returns error, stopping"
         stop
      endif
      nifqaid(ifqaid)=nifqaid(ifqaid)+1
      ncursou(cursou)=ncursou(cursou)+1
      nistoke(istoke)=nistoke(istoke)+1
      if((ia1 .ne. ia1l) .or.  (ia2 .ne. ia2l))then
         print 1003,iret,tutc,ia1,ia2,ifqaid,cursou,curint,
     >              istoke,dsb,crslgt
         print 1004,ia1l,ia2l,nifqaid,nistoke
       ia1l=ia1
       ia2l=ia2
 1003    format("crspec:",i4," ",E12.6,4i5,f5.1,3i4,12E7.3)
 1004    format("last had if sou stok=",2i3,16I5,":",4I6)
       do i=1,16
         nifqaid(i)=0
       enddo
       do i=1,10
         ncursou(i)=0
       enddo
       do i=1,4
         nistoke(i)=0
       enddo
      endif
c     do i=1,64
c        test(i+64*(ifqaid-1))=test(i+64*(ifqaid-1))+
c    >            sqrt(crossp(1,i)*crossp(1,i)
c    >                       +crossp(2,i)*crossp(2,i))
c     enddo
      if(iret .eq. 0)goto 666        !Ok, back for more
      if(iret .lt. 0)print *,"iret -ve, valid end "
c     do i=1,256
c      print *,i,test(i)
c     enddo
      end
